#include <OSA.h>


#if   defined(__OSAPICC18__)
    #include <pic18.h>
#elif defined (__OSAPICC__)
    #include <pic.h>
#endif


//------------------------------------------------------------------------------
#ifdef __OSAMCC18__
#pragma udata access ACCESS
#endif



NEAR OST_SYSTEM_FLAGS   OS_Flags;
NEAR __osa_uint8 _OS_temp;
NEAR __osa_uint8 _OS_tempH;




OST_TASK_POINTER NEAR _OS_CurTask;    //  

#ifdef OS_ENABLE_PRIORITY
    OST_TASK_POINTER NEAR _OS_BestTask;   //     (   OS_Sched() )
    OST_TASK_POINTER NEAR _OS_LastTask;   //   
    NEAR __osa_uint8 _OS_best_priority;

#endif

//------------------------------------------------------------------------------
NEAR OST_TASK_STATE     OS_state;

#ifdef OS_ENABLE_TIMER

    #ifdef OS_SLOW_TIMERS
        NEAR OST_TIMER          OS_Ticks;               //   (   0)
    #elif OS_TIMERS24 > 0
        NEAR __osa_uint8 OS_Ticks;
    #endif

    #ifdef OS_ENABLE_PTIMERS
        NEAR OST_PTIMER_CB _OS_PTimers;                  //    
    #endif
#endif

#ifdef __OSAMCC18__
#pragma udata
#endif
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
#if OS_BSEMS > 0
            #if OS_BANK_BSEM == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_bsems
                #endif
            #endif
OS_BSEM_BANK __osa_uint8 OS_BSems[(OS_BSEMS + 7) / 8];
            #if OS_BANK_BSEM == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------




//------------------------------------------------------------------------------
//    
            #if OS_BANK_TASKS == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_tasks
                #endif
            #endif
OS_TASKS_BANK OST_TCB OS_TaskVars[OS_TASKS];
            #if OS_BANK_TASKS == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
//------------------------------------------------------------------------------





//------------------------------------------------------------------------------
//    
#if OS_TIMERS > 0
            #if OS_BANK_TIMEOUTS == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timeout
                #endif
            #endif
OS_TIMEOUTS_BANK __osa_uint8 OS_Timeouts[(OS_TIMERS + 7) / 8];
            #if OS_BANK_TIMEOUTS == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
#if OS_TIMERS32 > 0
            #if OS_BANK_TIMERS32 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers32
                #endif
            #endif
OS_TIMERS32_BANK __osa_uint32 OS_Timers32[OS_TIMERS32];   //   
            #if OS_BANK_TIMERS32 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------
#if OS_TIMERS24 > 0
            #if OS_BANK_TIMERS24 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers24
                #endif
            #endif
OS_TIMERS24_BANK __osa_uint16 OS_Timers24[OS_TIMERS24];   //   
            #if OS_BANK_TIMERS24 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------
#if OS_TIMERS16 > 0
            #if OS_BANK_TIMERS16 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers16
                #endif
            #endif
OS_TIMERS16_BANK __osa_uint16 OS_Timers16[OS_TIMERS16];   //   
            #if OS_BANK_TIMERS16 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------
#if OS_TIMERS8 > 0
            #if OS_BANK_TIMERS8 == 0
                #ifdef __OSAMCC18__
                #pragma udata access os_timers8
                #endif
            #endif
OS_TIMERS8_BANK __osa_uint8 OS_Timers8[OS_TIMERS8];   //   
            #if OS_BANK_TIMERS8 == 0
                #ifdef __OSAMCC18__
                #pragma udata
                #endif
            #endif
#endif
//------------------------------------------------------------------------------




//------------------------------------------------------------------------------
//      , .. PICC   
// #locate,     #ifdef'
#ifdef __OSACCS18__
#include "osa_ccs18_locate.h"
#endif












/**************************************************************************************************
 * 
 *                                       M C C 1 8 
 *
 *
 **************************************************************************************************/

#if defined(__OSA18__)

/************************************************************************/
/*                          */
/************************************************************************/

#ifdef __OSAPICC18__
    asm("    global _OS_SchedRetPoint   ");
    asm("_OS_SchedRetPoint:             ");
void _os_schedretpoint()
#else
void OS_SchedRetPoint (void)
#endif
{
    #if defined(OS_ENABLE_PRIORITY)
        _fsr = (_FSR_TYPE)&_OS_CurTask->State;
        _OS_SetIndfReady();
    #endif

    _fsr = (_FSR_TYPE)&_OS_CurTask->cTempFSR1;
    _postdec = _fsr1l - _OS_tempH;
    _OS_SavePC();
    #ifdef __OSAPICC18__
        asm("    global _OS_SchedRetPointNoSave   ");
        asm("_OS_SchedRetPointNoSave:             ");
    #endif
    _PIC18_POP();
}

/************************************************************************/
/*                        */
/************************************************************************/
#ifndef __OSAPICC18__
void OS_SchedRetPointNoSave (void)
{
    _PIC18_POP();
}
#endif

/************************************************************************/
/*                                                                      */
/************************************************************************/
//------------------------------------------------------------------------------
//      
//    GOTO :
//      OS_ClearReady()
//      OS_ClearReadySetCanContinue()
// ,   -  ,  
//------------------------------------------------------------------------------
void _OS_ClrReadySetClrCanContinue (void);


#if defined(__OSAPICC18__)
    asm("   global  _OS_ClearReady");
    asm("_OS_ClearReady:     ");
    asm("   bcf     __OS_temp, 0, c    ");
    asm("   global  __OS_ClrReadySetClrCanContinue  ");
    asm("   goto    __OS_ClrReadySetClrCanContinue  ");
#else
    void OS_ClearReady (void)
    {
        _OS_temp = 0;

    #if defined(__OSACCS18__)
        _OS_ClrReadySetClrCanContinue();
    #endif
    #if defined(__OSAMCC18__)
        _asm    goto    _OS_ClrReadySetClrCanContinue   _endasm
    #endif
    }
#endif

#if defined(__OSAPICC18__)
    asm("   global  _OS_ClearReadySetCanContinue");
    asm("_OS_ClearReadySetCanContinue:     ");
    asm("   bsf     __OS_temp, 0, c    ");
    asm("   global  __OS_ClrReadySetClrCanContinue  ");
    asm("   goto    __OS_ClrReadySetClrCanContinue  ");
#else
    void OS_ClearReadySetCanContinue (void)
    {
        _OS_temp = 0xFF;
    #if defined(__OSACCS18__)
        _OS_ClrReadySetClrCanContinue();
    #endif
    #if defined(__OSAMCC18__)
        _asm    goto    _OS_ClrReadySetClrCanContinue   _endasm
    #endif
    }
#endif


void _OS_ClrReadySetClrCanContinue (void)
{
    #if defined(OS_ENABLE_PRIORITY) || defined(OS_ENABLE_TIMER)
        _fsr = (_FSR_TYPE)&_OS_CurTask->State;
        #if defined(OS_ENABLE_PRIORITY)
            _OS_ClearIndfReady();
        #endif

        #if defined(OS_ENABLE_TIMER)
            _OS_ClearIndfCanContinue();
            if (_OS_temp & 0x01) _OS_SetIndfCanContinue();
        #endif
    #endif


    OS_Flags.bEventError = 0;
    _fsr = (_FSR_TYPE)&_OS_CurTask->cTempFSR1;
    _postdec = _fsr1l - _OS_tempH;
    _OS_SavePC();

    #if defined(__OSACCS18__)
        _PIC18_POP();
    #endif
    #ifndef OS_ENABLE_PRIORITY
        _PIC18_POP();
    #endif
}



#endif // __OSA18__









/**************************************************************************************************
 * 
 * C O U N T I N G    S E M A P H O R E S
 *
 * (OS_ENABLE_CSEM must be defined in OSAcfg.h)
 *
 **************************************************************************************************/


#ifdef OS_ENABLE_CSEM

#if OS_CSEM_SIZE > 1
/************************************************************************/
/*                                              */
/************************************************************************/

    bit _OS_CheckCSem(OST_CSEM *pCSem)
    {
        char cGIETemp;
        cGIETemp = OS_DI();
        if (*pCSem) cGIETemp |= 1;
        OS_RI(cGIETemp);
        if (cGIETemp & 1) return 1;
        return 0;
    }

/************************************************************************/
/*  ()                                  */
/************************************************************************/
    void _OS_ClearCSem(OST_CSEM *pCSem)
    {
        char cGIETemp;
        cGIETemp = OS_DI();
        *pCSem = 0;
        OS_RI(cGIETemp);
    }

#endif


/************************************************************************/
/*     1                                    */
/************************************************************************/
void _OS_SignalCSem (OST_CSEM *pCSem)
{
    #ifdef OS_ENABLE_INT_SERVICE
        char cGIETemp;
        cGIETemp = OS_DI();
    #endif

    OS_Flags.bEventError = 0;               //   ,    

    //------------------------------------------------------------------------------
    //    
    #if OS_CSEM_SIZE == 1
    
        #if defined(__OSAPICC__) || defined(__OSAPICC18__)
            _fsr = (_FSR_TYPE)pCSem;
            #ifdef __OSAPICC__
                _status &= 0x7F;        //  IRP
            #endif
            _indf++;
            if (!_indf)
            {
                _indf--;
                OS_Flags.bEventError = 1;
            }
        #else
            (*pCSem)++;
            if (!*pCSem) {
                (*pCSem) = 0xFF;
                OS_Flags.bEventError = 1;
            }
        #endif

    //------------------------------------------------------------------------------
    //    
    #elif OS_CSEM_SIZE == 2
        #if  defined(__OSAPICC__)
            _fsr = (_FSR_TYPE)pCSem;
            _status &= 0x7F;        //  IRP
            asm("\t    movlw    1     ");
            asm("\t    addwf    __indf,f    ");
            asm("\t    incf     __fsr, f    ");
            asm("\t    btfsc    __status, 0     ");
            asm("\t    incf     __indf,f     ");
            asm("\t    movf     __indf, w     ");
            asm("\t    decf     __fsr, f     ");
            asm("\t    iorwf    __indf, w      ");
            if (ZERO) {
                asm("\t    movlw    -1     ");
                asm("\t    movwf    __indf     ");
                asm("\t    incf     __fsr,f     ");
                asm("\t    movwf    __indf     ");
                OS_Flags.bEventError = 1;
            }
        #else
            (*pCSem)++;
            if (!*pCSem) {          //   ,    
                (*pCSem) = 0xFFFF;
                OS_Flags.bEventError = 1;
            }
        #endif
    //------------------------------------------------------------------------------
    //    
    #else 
        (*pCSem)++;
        if (!*pCSem) {          //   ,    
            (*pCSem) = 0xFFFFFFFF;
            OS_Flags.bEventError = 1;
        }
    #endif
    //------------------------------------------------------------------------------
    
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
}

#endif











/****************************************************************************************************
 * 
 *       GIEH:GIEL
 * 
 * char OS_DI (void)   
 *
 ****************************************************************************************************/
/****************************************************************************************************
 * 
 *       OS_DI 
 * 
 * void OS_RI (char)   
 *
 ****************************************************************************************************/
#if defined(__OSAPICC18__)


    asm("   global _OS_DI           ");
    asm("_OS_DI:                    ");
    asm("   dw      0xFFFF          ");
    asm("   movf    __intcon, w, c   ");
    asm("   andlw   0xC0            ");
    asm("_DIH_REPEAT:               ");
    asm("   bcf     __intcon, 7, c   ");
    asm("   btfsc   __intcon, 7, c   ");
    asm("   bra     _DIH_REPEAT     ");
    
    asm("   btfss   __rcon, 7, c     ");
    asm("   bra     _DI_EXIT        ");
    asm("_DIL_REPEAT:               ");
    asm("   bcf     __intcon, 6, c   ");
    asm("   btfsc   __intcon, 6, c   ");
    asm("   bra     _DIL_REPEAT     ");
    asm("_DI_EXIT:                  ");
    asm("   return                  ");
    asm("   dw      0xFFFF          ");


    asm("   global  _OS_RI          ");
    asm("_OS_RI:                    ");
    asm("   dw      0xFFFF          ");
    asm("   btfsc   _WREG, 7, c     ");
    asm("   bsf     __intcon, 7, c   ");
    asm("   btfsc   __rcon, 7, c     ");
    asm("   btfss   __wreg, 6, c     ");
    asm("   bra     _RI_EXIT        ");
    asm("   bsf     __intcon, 6, c   ");
    asm("_RI_EXIT:                  ");
    asm("   return                  ");
    asm("   dw      0xFFFF          ");



#elif defined(__OSAPICC__)
/****************************************************************************************************
 * 
 *       GIE
 * 
 * char OS_DI (void)   
 *
 ****************************************************************************************************/

    asm("   global _OS_DI           ");
    asm("_OS_DI:                    ");
    asm("   clrf    __status        ");
    asm("   movf    __intcon, w      ");
    asm("   andlw   0x80            ");
    asm("_DI_REPEAT:                ");
    asm("   bcf     __intcon, 7      ");
    asm("   btfss   __intcon, 7      ");
    asm("   return                  ");
    asm("   goto    _DI_REPEAT      ");



#elif defined(__OSAMCC18__)
    char OS_DI (void)
    {
        _asm
            movf    _intcon, 0, 0
            andlw   0xC0
        _DIH_REPEAT:
            bcf     _intcon, 7, 0
            btfsc   _intcon, 7, 0
            bra     _DIH_REPEAT
            btfss   _rcon, 7, 0
            bra     _DI_EXIT
        _DIL_REPEAT:
            bcf     _intcon, 6, 0
            btfsc   _intcon, 6, 0
            bra     _DIL_REPEAT
        _DI_EXIT:
        _endasm
    }


    void _OS_RI ()
    {
        _asm
            btfsc   _wreg, 7, 0
            bsf     _intcon, 7, 0
            btfsc   _rcon, 7, 0
            btfss   _wreg, 6, 0
            bra     _RI_EXIT
            bsf     _intcon, 6, 0
        _RI_EXIT:
        _endasm

    }


#else       //    


    char OS_DI (void)
    {
        char temp;
        temp = _intcon & 0xC0;
        do {
            _intcon &= 0x7F;
        } while (_intcon & 0x80);
        if (_rcon & 0x80)
        {
            do {
                _intcon &= 0xBF;
            } while (_intcon & 0x40);
        }
        return temp;
    }


    void OS_RI (char temp)
    {
        if (temp & 0x80) _intcon |= 0x80;
        if (_rcon & 0x80)
            if (temp & 0x40) _intcon |= 0x40;
    }

#endif  // __OSACCS18__









 
    
    
/****************************************************************************************************
 * 
 *        
 * 
 *
 ****************************************************************************************************/
//------------------------------------------------------------------------------
#ifdef OS_ENABLE_CRITICAL_SECTION
//------------------------------------------------------------------------------
    
/************************************************************************/
/*                                                */
/************************************************************************/
void OS_EnterCriticalSection (void)
{
    char temp;
    temp = OS_DI();
    OS_Flags.bInCriticalSection = 1; 

    OS_Flags.bGIE_CTemp = 0;
    if (temp & 0x80) OS_Flags.bGIE_CTemp = 1;

    #if defined(__OSA18__)
        OS_Flags.bGIEL_CTemp = 0;
        if (temp & 0x40) OS_Flags.bGIEL_CTemp = 1;
    #endif
}

/************************************************************************/
/*                                              */
/************************************************************************/
void OS_LeaveCriticalSection (void)
{
    char temp;
    OS_Flags.bInCriticalSection = 0; 
    temp = 0;
    if (OS_Flags.bGIE_CTemp) temp |= 0x80;
    #if defined(__OSA18__)
        if (OS_Flags.bGIEL_CTemp) temp |= 0x40;
    #endif
    OS_RI(temp);
}

//------------------------------------------------------------------------------
#endif      //     #ifdef OS_ENABLE_CRITICAL_SECTION
//------------------------------------------------------------------------------


















//------------------------------------------------------------------------------
#ifdef OS_ENABLE_TIMER

#ifndef OS_FAST_TIMERS
/****************************************************************************************************
 * 
 *                                  
 *  
 *     ( OSAcfg.h   OS_SLOW_TIMERS)
 *
 ****************************************************************************************************/
            

    OST_TIMER _cur_os_ticks;

/************************************************************************/
/*                                                                      */
/*         */
/* (  )                                         */
/*                                                                      */
/************************************************************************/
    void _OS_GetTicks (void)
    {
        do {
            _cur_os_ticks = OS_Ticks;
        } while (_cur_os_ticks != OS_Ticks);    
    }    


/************************************************************************/
/*                                                                      */
/*                                    */
/* (  )                                         */
/*                                                                      */
/************************************************************************/
    void _OS_InitDelay (OST_TIMER Delay)
    {

        OST_TASK_STATE state;
    
        state = _OS_CurTask->State;

        if (Delay)
        {
            _OS_GetTicks();


            _cur_os_ticks += Delay;
            state.bDelay = 1;
        } else {
            state.bDelay = 0;
        }
        state.bCanContinue = 0;
        _OS_CurTask->State = state;
        _OS_CurTask->Timer = _cur_os_ticks;
    }

/************************************************************************/
/*                             */
/* (  )                                         */
/************************************************************************/
    bit _OS_CheckDelays ()
    {


        //     

        _OS_GetTicks();


        _cur_os_ticks = _OS_CurTask->Timer - _cur_os_ticks;

        //  
        if (_cur_os_ticks > OS_MAX_DELAY) 
        {
            _OS_CurTask->State.bDelay = 0;
            return 1;
        }
        if (_OS_CurTask->State.bCanContinue) return 1;
        return 0;
    }

#endif  // #ifndef OS_FAST_DELAYS


#if defined(OS_FAST_TIMERS)


/****************************************************************************************************
 * 
 *                                  
 *  
 *     ( OSAcfg.h  OS_SLOW_TIMERS      )
 *
 ****************************************************************************************************/
/************************************************************************/
/*                                                                      */
/*                                    */
/* (  )                                         */
/*                                                                      */
/************************************************************************/
    void _OS_InitDelay (OST_TIMER Delay)
    {

        #if defined(__OSAMCC18__)
            char temp;
            temp = 0;               //    MCC18:     Delay
            if (Delay) temp = 1;    //   FSR0 (.  (temp & 1))
        #endif
        
        _fsr = (_FSR_TYPE)&_OS_CurTask->State;
        _SET_TASK_IRP();
        _OS_ClearIndfCanContinue();
        _OS_ClearIndfDelay();
        
      #if defined(__OSAMCC18__)
        if (temp & 1)           
      #else
        if (Delay)
      #endif
        {
                #if   OS_TIMER_SIZE == 1
                    *((char*)&Delay + 0) ^= 0xFF;
                #endif
                #if   OS_TIMER_SIZE == 2
                    *((char*)&Delay + 0) ^= 0xFF;
                    *((char*)&Delay + 1) ^= 0xFF;
                #endif
                #if   OS_TIMER_SIZE == 4
                    *((char*)&Delay + 0) ^= 0xFF;
                    *((char*)&Delay + 1) ^= 0xFF;
                    *((char*)&Delay + 2) ^= 0xFF;
                    *((char*)&Delay + 3) ^= 0xFF;
                #endif
                Delay ++;
            _OS_CurTask->Timer = Delay;
            _OS_CurTask->State.bDelay = 1;
        }
    }

//______________________________________________________________________________
//******************************************************************************
#endif  // #ifdef OS_FAST_DELAYS

#endif  // #ifdef OS_TIMER



    










    
    
    
    
    

    








/****************************************************************************************************
 * 
 * 
 *                                   
 *  
 *
 ****************************************************************************************************/

void OS_Init (void)
{

    #if (OS_BSEMS > 11*8) || (OS_TIMERS > 11*8)
        char n;
    #endif
    
    #ifdef OS_ENABLE_PRIORITY
        _OS_LastTask = (OS_TASKS_BANK OST_TASK_POINTER) &OS_TaskVars[OS_TASKS - 1];
    #endif
    
    //------------------------------------------------------------------------------
    //   
    #if OS_TIMERS > 11*8
        n = sizeof(OS_Timeouts);
        do {
            OS_Timeouts[n-1] = 0;
        } while (--n);
    #else
        #if OS_TIMERS > 0
            OS_Timeouts[0] = 0;
        #endif

        #if OS_TIMERS > 1*8
            OS_Timeouts[1] = 0;
        #endif

        #if OS_TIMERS > 2*8
            OS_Timeouts[2] = 0;
        #endif

        #if OS_TIMERS > 3*8
            OS_Timeouts[3] = 0;
        #endif

        #if OS_TIMERS > 4*8
            OS_Timeouts[4] = 0;
        #endif

        #if OS_TIMERS > 5*8
            OS_Timeouts[5] = 0;
        #endif

        #if OS_TIMERS > 6*8
            OS_Timeouts[6] = 0;
        #endif

        #if OS_TIMERS > 7*8
            OS_Timeouts[7] = 0;
        #endif

        #if OS_TIMERS > 8*8
            OS_Timeouts[8] = 0;
        #endif

        #if OS_TIMERS > 9*8
            OS_Timeouts[9] = 0;
        #endif

        #if OS_TIMERS > 10*8
            OS_Timeouts[10] = 0;
        #endif

    #endif
    
    #if defined(OS_ENABLE_TIMER) && defined(OS_ENABLE_PTIMERS)
        *((char*)&_OS_PTimers.Flags) = 0;
        _OS_PTimers.Flags.bActive = 1;    //    OS_CreatePTimer
    #endif

    //------------------------------------------------------------------------------
    //   
    #if OS_BSEMS > 11*8
        n = sizeof(OS_BSems);
        do {
            OS_BSems[n-1] = 0;
        } while (--n);
    #else
        #if OS_BSEMS > 0
            OS_BSems[0] = 0;
        #endif

        #if OS_BSEMS > 1*8
            OS_BSems[1] = 0;
        #endif

        #if OS_BSEMS > 2*8
            OS_BSems[2] = 0;
        #endif

        #if OS_BSEMS > 3*8
            OS_BSems[3] = 0;
        #endif

        #if OS_BSEMS > 4*8
            OS_BSems[4] = 0;
        #endif

        #if OS_BSEMS > 5*8
            OS_BSems[5] = 0;
        #endif

        #if OS_BSEMS > 6*8
            OS_BSems[6] = 0;
        #endif

        #if OS_BSEMS > 7*8
            OS_BSems[7] = 0;
        #endif

        #if OS_BSEMS > 8*8
            OS_BSems[8] = 0;
        #endif

        #if OS_BSEMS > 9*8
            OS_BSems[9] = 0;
        #endif

        #if OS_BSEMS > 10*8
            OS_BSems[10] = 0;
        #endif
    #endif

   
    //------------------------------------------------------------------------------
    #if OS_TASKS > 0
        _OS_CurTask = (OST_TASK_POINTER) OS_TaskVars;
        _OS_temp = OS_TASKS;
        do {
            _OS_StopTask();
            _OS_CurTask ++;
        } while (--_OS_temp);
    #endif
}













    
    
    
    
    
/****************************************************************************************************
 * 
 * 
 *                                      
 *  
 *
 ****************************************************************************************************/
    
/************************************************************************/
/*                                                                      */
/*                     */
/*                                   */
/*                                                                      */
/************************************************************************/

 
void _OS_StopTask (void)
{
    *((OS_TASKS_BANK char*)&_OS_CurTask->State) = 0;
    _OS_CurTask->pTaskPointer = 0;
}




/************************************************************************/
/*                                                                      */
/*     .                              */
/*  :                                                           */
/*      FSR -                                      */
/*      CARRY - =1 - ,                                                */
/*              =0 -    (  OS_TASKS)    */
/*                                                                      */
/************************************************************************/

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------

#ifdef OS_ENABLE_PRIORITY
bit _OS_CreateTask(unsigned char priority, OST_CODE_POINTER TaskAddr)
#else
bit _OS_CreateTask(OST_CODE_POINTER TaskAddr)
#endif
{
    OST_TASK_POINTER Task;

    #ifndef OS_ENABLE_PRIORITY
        char priority;
        priority = 0;
    #endif

    OS_Flags.bError = 0;

    Task = (OST_TASK_POINTER)OS_TaskVars;
    _OS_temp = OS_TASKS;
    do {
        if (!Task->State.bEnable)
        {
            ((OST_TASK_STATE*)&priority)->bEnable = 1;

            ((OST_TASK_STATE*)&priority)->bReady = 1;
            
            Task->pTaskPointer = TaskAddr;
            #ifdef OS_ENABLE_TIMER
                Task->Timer = 0;
            #endif
            #ifdef __OSA18__
                Task->cTempFSR1 = 0;
            #endif
            *((OS_TASKS_BANK char*)&Task->State) = priority;
            //    FSR =    
            #ifdef __OSAPICC18__
            _fsr = (OST_TASK_POINTER)Task;
            #endif
            OS_Flags.bError = 0;
            return 1;
        
        }
        Task ++;
    } while (_OS_temp--);
    //  ,     
    OS_Flags.bError = 1;
    return 0;
}






























/****************************************************************************************************
 * 
 * 
 *                              
 *  
 *       
 *
 ****************************************************************************************************/


#ifdef OS_ENABLE_TIMER
#ifndef OS_USE_INLINE_TIMER
void OS_Timer (void)
{                            
    __OS_TimerInline(os_timer);
}
#endif
#endif






 /******************************************************************************************
 *
 *             P T I M E R '    
 *
 ******************************************************************************************/
#ifdef OS_ENABLE_PTIMERS

/************************************************************************/
/*                                                                      */
/************************************************************************/
void _OS_CreatePTimer (OST_PTIMER *ptimer)
{
    _OS_temp = OS_DI();
    _fsr = (_FSR_TYPE) ptimer;
    //------------------------------------------------------------------------------
    #if defined(__OSAPICC__)
        _indf = *((char*)&_OS_PTimers.Flags); //  bActive,
                                              //  bTimeout,
                                              //  bRun
                                              //  bNextEnable;
        _fsr++;
        _indf = (_FSR_TYPE)_OS_PTimers.Next;

        _fsr++;
        _indf = 0;
        _fsr++;
        #if  OS_TIMER_SIZE >= 2
        _indf = 0;
        _fsr++;
        #endif
        #if  OS_TIMER_SIZE == 4
        _indf = 0;
        _fsr++;
        _indf = 0;
        #endif

    #elif defined(__OSAPICC18__) || defined(__OSAMCC18__) || defined(__OSACCS18__)
        _postinc = *((NEAR char*)&_OS_PTimers.Flags);   //  bActive,
                                                        //  bTimeout,
                                                        //  bRun
                                                        //  bNextEnable
        _postinc = *((NEAR char*)&_OS_PTimers.Next + 0);
        _postinc = *((NEAR char*)&_OS_PTimers.Next + 1);
        _postinc = 0;
        #if  OS_TIMER_SIZE >= 2
        _postinc = 0;
        #endif
        #if  OS_TIMER_SIZE == 4
        _postinc = 0;
        _postinc = 0;
        #endif

    #endif



    _OS_PTimers.Next = (OST_PTIMER*)ptimer;
    _OS_PTimers.Flags.bNextEnable = 1;
    OS_RI(_OS_temp);
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
void _OS_DeletePTimer (OST_PTIMER *ptimer)
{
    OST_PTIMER *ptcb;
    char flags;

    //------------------------------------------------------------------------------
    #if defined(__OSAPICC__)
    //______________________________________________________________________________
        _fsr = ((_FSR_TYPE)ptimer);
        flags = _indf;
        _OS_ClearIndfTimerActive;           //   
        _fsr++;
        ptcb = (_FSR_TYPE)_indf;
        _fsr = (_FSR_TYPE)&_OS_PTimers;
        //     
    REPEAT:
        if (_OS_CheckIndfTimerNextEnable)   // ,   
        {
            _fsr++;
            if ((_FSR_TYPE)_indf == (_FSR_TYPE)ptimer)  // ,    
            {
                _OS_temp = OS_DI();         //  
                _indf = *((char*)&ptcb);    //  
                _fsr--;                     
                //  ,      
                if (!((OST_PTIMER_FLAGS*)&flags)->bNextEnable) _OS_ClearIndfTimerNextEnable;
                OS_RI(_OS_temp);
                return;
            }
            _fsr = (_FSR_TYPE)_indf;
            goto REPEAT;
        }
    //------------------------------------------------------------------------------
    #elif defined(__OSAPICC18__)
    //______________________________________________________________________________
        _fsr = (_FSR_TYPE)ptimer;
        _OS_ClearIndfTimerActive;           //   
        flags = _postinc;
        *((char*)&ptcb + 0) = _postinc;
        *((char*)&ptcb + 1) = _postinc;
        _fsr = (_FSR_TYPE)&_OS_PTimers;
    REPEAT:
        if (_OS_CheckPostincTimerNextEnable)
        {
            if (_indf == *((char*)&ptimer + 0))
            {
                if (_preinc == *((char*)&ptimer + 1)){
                    _OS_temp = OS_DI();
                    _postdec = *((char*)&ptcb + 1);
                    _postdec = *((char*)&ptcb + 0);
                    if (!((OST_PTIMER_FLAGS*)&flags)->bNextEnable) _OS_ClearIndfTimerNextEnable;
                    return;
                }
                _fsr--;
            } 
            asm("   movf    __postinc, w, c     ");
            asm("   movff   __indf, __fsr + 1     ");
            asm("   movwf   __fsr + 0, c      ");
            goto REPEAT;
        }
    //------------------------------------------------------------------------------
    #elif defined(__OSAMCC18__)
    //______________________________________________________________________________
        _fsr = (_FSR_TYPE)ptimer;
        _OS_ClearIndfTimerActive;           //   
        flags = _postinc;
        *((char*)&ptcb + 0) = _postinc;
        *((char*)&ptcb + 1) = _postinc;
        _fsr = (_FSR_TYPE)&_OS_PTimers;
    REPEAT:
        if (_OS_CheckPostincTimerNextEnable)
        {
            if (_indf == *((char*)&ptimer + 0))
            {
                if (_preinc == *((char*)&ptimer + 1)){
                    _OS_temp = OS_DI();
                    _postdec = *((char*)&ptcb + 1);
                    _postdec = *((char*)&ptcb + 0);
                    if (!((OST_PTIMER_FLAGS*)&flags)->bNextEnable) _OS_ClearIndfTimerNextEnable;
                    return;
                }
                _fsr--;
            } 
            _asm
                movf    _postinc, 0, 0
                movff   _indf, _fsr + 1
                movwf   _fsr + 0, 0
            _endasm
        }
    //------------------------------------------------------------------------------
    #elif defined(__OSACCS18__)
    //______________________________________________________________________________
        _fsr = (_FSR_TYPE)ptimer;
        _OS_ClearIndfTimerActive;           //   
        flags = _postinc;
        *((char*)&ptcb + 0) = _postinc;
        *((char*)&ptcb + 1) = _postinc;
        _fsr = (_FSR_TYPE)&_OS_PTimers;
    REPEAT:
        if (_OS_CheckPostincTimerNextEnable)
        {
            if (_indf == *((char*)&ptimer + 0))
            {
                if (_preinc == *((char*)&ptimer + 1)){
                    _OS_temp = OS_DI();
                    _postdec = *((char*)&ptcb + 1);
                    _postdec = *((char*)&ptcb + 0);
                    if (!((OST_PTIMER_FLAGS*)&flags)->bNextEnable) _OS_ClearIndfTimerNextEnable;
                    return;
                }
                _fsr--;
            } 
            #asm
                movf    _postinc, 0, 0
                movff   _indf, _fsr + 1
                movwf   _fsr + 0, 0
            #endasm
        }
        
        
    //------------------------------------------------------------------------------
    #endif
    //______________________________________________________________________________
        
}




#endif  //  OS_ENABLE_PTIMERS


























/****************************************************************************************************
 * 
 *                                /               
 *                  
 *
 * (  )
 *
 ****************************************************************************************************/


#if     defined(__OSA16__)
    
    bit _OS_CheckEvent (char bEvent)

#elif   defined(__OSAMCC18__)
    
    void _OS_CheckEvent (void)
    #define bEvent  _OS_temp

#elif   defined(__OSA18__)

    void _OS_CheckEvent (char bEvent)

#endif
    {
        if (bEvent) bEvent |= 1;
        OS_Flags.bTimeout = 0;
        _fsr = (_FSR_TYPE)&_OS_CurTask->State;
        _SET_TASK_IRP();
    #ifdef OS_ENABLE_PRIORITY
        if (_OS_CheckIndfReady())
    #endif
        {
            if (bEvent & 1)
            {
                _OS_ClearIndfDelay();
                #ifdef __OSA16__
                    return 1;            
                #endif
                #ifdef __OSA18__
                    return;
                #endif
            }
            #ifdef OS_ENABLE_TIMER
                if (_OS_CheckIndfTimeout() && _OS_CheckIndfCanContinue())
                {
                    OS_Flags.bTimeout = 1;
                    #ifdef __OSA16__
                        return 1;
                    #endif
                    #ifdef __OSA18__
                        return;
                    #endif
                }
            #endif
            _OS_ClearIndfReady();
            #ifdef __OSA16__
                return 0;
            #endif
            #ifdef __OSA18__
                goto NOT_YET;
            #endif
        }
        #ifdef OS_ENABLE_PRIORITY
            #ifdef OS_ENABLE_TIMER
                if ((bEvent & 1) || (_OS_CheckIndfTimeout() && _OS_CheckIndfCanContinue())) _OS_SetIndfReady();
            #else
                if (bEvent & 1) _OS_SetIndfReady();
            #endif
            #ifdef __OSA16__
                return 0;
            #endif
        #endif
        #ifdef __OSA18__
        NOT_YET:
            //  PIC18:        
            _PIC18_POP();
            #ifdef __OSAPICC18__
                _OS_Return();
            #endif
        #endif
    }


    

        

        






/****************************************************************************************************
 * 
 * 
 *                                                    
 *  
 *
 ****************************************************************************************************/


/************************************************************************/
/*                                                                      */
/*                           */
/*  1,                        */
/*                                                                      */
/************************************************************************/

#ifdef OS_ENABLE_QSMSG
void _OS_SendQSMsg (OST_QSMSG *pQSMsg, OST_SMSG SMsg)
{
    OST_QUEUE_CONTROL   q;
    char temp;

    #ifdef OS_ENABLE_INT_SERVICE
        char cGIETemp;
        cGIETemp = OS_DI();
    #endif
    
    q = pQSMsg->Q;
    OS_Flags.bEventError = 0;
    
    if (q.cSize == q.cFilled)                               //   ,    .
    {                                                       //   OS_SendQSMsg    
        pQSMsg->pSMsg[q.cBegin] = SMsg;                     // ,        .
        q.cBegin++;                                         //       OS_SendQSMsgNoWait,
        if (q.cBegin == q.cSize) q.cBegin = 0;              //       ,  
                                                            //   .
        OS_Flags.bEventError = 1;
        goto EXIT;
    }
    temp = q.cBegin + q.cFilled;
    if (temp >= q.cSize) temp -= q.cSize;
    pQSMsg->pSMsg[temp] = SMsg;
    q.cFilled++;
EXIT:
    pQSMsg->Q = q;
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
}
#endif


/************************************************************************/
/*                                                                      */
/*                                 */
/*                                                                      */
/************************************************************************/

#ifdef OS_ENABLE_QSMSG
OST_SMSG _OS_GetQSMsg (OST_QSMSG *pQSMsg)
{
    OST_QUEUE_CONTROL   q;
    char temp;
    #ifdef OS_ENABLE_INT_SERVICE
        char cGIETemp;
        cGIETemp = OS_DI();
    #endif

    q = pQSMsg->Q;
    temp = q.cBegin;
    q.cBegin++;
    if (q.cBegin >= q.cSize) q.cBegin = 0;
    q.cFilled--;
    pQSMsg->Q = q;
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
    return pQSMsg->pSMsg[temp];
}
#endif




/************************************************************************/
/*                                                                      */
/*                                   */
/*  1,                        */
/*                                                                      */
/************************************************************************/

#ifdef OS_ENABLE_QMSG

void _OS_SendQMsg (OST_QMSG *pQMsg, OST_MSG Msg)
{
    OST_QUEUE_CONTROL   q;
    char temp;

    #ifdef OS_ENABLE_INT_SERVICE
        char cGIETemp;
        cGIETemp = OS_DI();
    #endif
    q = pQMsg->Q;
    OS_Flags.bEventError = 0;
    
    if (q.cSize == q.cFilled)                               //   ,    .
    {                                                       //   OS_SendQSMsg    
        pQMsg->pMsg[q.cBegin] = Msg;                        // ,        .
        q.cBegin++;                                         //       OS_SendQSMsgNoWait,
        if (q.cBegin == q.cSize) q.cBegin = 0;              //       ,  
                                                            //   .
        OS_Flags.bEventError = 1;
        goto EXIT;
    }
    temp = q.cBegin + q.cFilled;
    if (temp >= q.cSize) temp -= q.cSize;
    pQMsg->pMsg[temp] = Msg;
    q.cFilled++;
EXIT:
    pQMsg->Q = q;
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
}


#endif


/************************************************************************/
/*                                                                      */
/*                                         */
/*                                                                      */
/************************************************************************/

#ifdef OS_ENABLE_QMSG
OST_MSG _OS_GetQMsg (OST_QMSG *pQMsg)
{
    OST_QUEUE_CONTROL   q;
    char temp;
    #ifdef OS_ENABLE_INT_SERVICE
        char cGIETemp;
        cGIETemp = OS_DI();
    #endif

    q = pQMsg->Q;
    temp = q.cBegin;
    q.cBegin++;
    if (q.cBegin >= q.cSize) q.cBegin = 0;
    q.cFilled--;
    pQMsg->Q = q;
    #ifdef OS_ENABLE_INT_SERVICE
        OS_RI(cGIETemp);
    #endif
    return pQMsg->pMsg[temp];
}
#endif




