//*********************************************************************************/
#ifndef _OSA
#define _OSA

#define __OSA__

#define __OSAVERSION__		80906

#include "OSAcfg.h"



/************************************************************************/
/*                                         */
/************************************************************************/

#if   defined(__PICC18__)

    #define __OSAPICC18__
    #define __OSA18__

#elif defined(__18CXX)

    #define __OSAMCC18__
    #define __OSA18__

#elif defined(__PCH__)

    #define __OSACCS18__
    #define __OSA18__

#else
    #define __OSAPICC__
    #define __OSA16__

#endif



//------------------------------------------------------------------------------
//   
#ifdef OS_ENABLE_ALL
    #undef OS_ENABLE_PRIORITY
    #undef OS_ENABLE_TIMER
    #undef OS_ENABLE_CSEM
    #undef OS_ENABLE_QMSG
    #undef OS_ENABLE_QSMSG
    #undef OS_ENABLE_PTIMERS

    #undef OS_PRIORITY_MODE
    #undef OS_TIMER_ENABLE
    #undef OS_CSEM_ENABLE
    #undef OS_QMSG_ENABLE
    #undef OS_QSMSG_ENABLE
    #undef OS_PTIMERS_ENABLE
    


    #define OS_ENABLE_PRIORITY
    #define OS_ENABLE_TIMER
    #define OS_ENABLE_CSEM
    #define OS_ENABLE_QMSG
    #define OS_ENABLE_QSMSG
    #define OS_ENABLE_PTIMERS
#endif


#ifdef OS_PRIORITY_MODE
#define OS_ENABLE_PRIORITY              //   ,      
#endif

#ifdef OS_TIMER_ENABLE
#define OS_ENABLE_TIMER                 // ,     (OS_Delay    )
#endif

#ifdef OS_CSEM_ENABLE
#define OS_ENABLE_CSEM                  // ,     
#endif

#ifdef OS_QMSG_ENABLE
#define OS_ENABLE_QMSG                  // ,     
#endif

#ifdef OS_QSMSG_ENABLE
#define OS_ENABLE_QSMSG                 // ,      
#endif


#ifdef OS_PTIMERS_ENABLE
#define OS_ENABLE_PTIMERS
#endif

#ifndef OS_SLOW_TIMERS
#define OS_FAST_TIMERS
#endif





#ifdef __OSACCS18__
    #define __osa_uint8     unsigned int8
    #define __osa_uint16    unsigned int16
    #define __osa_uint32    unsigned int32
#else
    typedef unsigned char    __osa_uint8;
    typedef unsigned int     __osa_uint16;
    typedef unsigned long    __osa_uint32;
#endif






/****************************************************************************************************
 *
 *                                                 
 *
 ****************************************************************************************************/

#if defined(OS_BANK) || defined(OS_TASKS_BANK)  || defined(OS_TIMERS_BANK)  ||  defined(OS_TIMERS8_BANK)  ||  defined(OS_TIMERS16_BANK)  || defined(OS_TIMERS24_BANK)  || defined(OS_TIMERS32_BANK)  || defined(OS_TIMEOUTS_BANK)  || defined(OS_BSEM_BANK)
#error "Constants OS_xxx_BANK are not allowed now (use OS_BANK_xxx instead, see manual (3.4))"
#endif



#ifndef OS_BANK_OS
#define OS_BANK_OS      0
#endif

#if defined(OS_BANK_TASK) && !defined(OS_BANK_TASKS)
#define OS_BANK_TASKS   OS_BANK_TASK
#endif


#ifndef OS_BANK_TASKS
#define OS_BANK_TASKS       OS_BANK_OS       //    
#endif

#ifndef OS_BANK_TIMERS
#define OS_BANK_TIMERS      OS_BANK_OS
#endif

#ifndef OS_BANK_TIMERS8 
#define OS_BANK_TIMERS8     OS_BANK_TIMERS       //   
#endif

#ifndef OS_BANK_TIMERS16
#define OS_BANK_TIMERS16    OS_BANK_TIMERS       //   
#endif

#ifndef OS_BANK_TIMERS24
#define OS_BANK_TIMERS24    OS_BANK_TIMERS       //   
#endif

#ifndef OS_BANK_TIMERS32
#define OS_BANK_TIMERS32    OS_BANK_TIMERS       //   
#endif

#ifndef OS_BANK_TIMEOUTS
#define OS_BANK_TIMEOUTS    OS_BANK_TIMERS
#endif


#if defined(OS_BANK_BSEMS) && !defined(OS_BANK_BSEM)
#define OS_BANK_BSEM   OS_BANK_BSEMS
#endif


#ifndef OS_BANK_BSEM
#define OS_BANK_BSEM      OS_BANK_OS       //    
#endif


//------------------------------------------------------------------------------
#if defined(__OSAPICC18__)
    #define NEAR    near
    #define bank0   near
    #define bank1   bdata
    #define bank2   bdata
    #define bank3   bdata
#endif
//------------------------------------------------------------------------------
#if defined (__OSAMCC18__)
    #define NEAR    near
    #define bank0   near
    #define bank1
    #define bank2
    #define bank3
    #define bit     __osa_uint8
#endif
//------------------------------------------------------------------------------
#if defined (__OSACCS18__)
    #define NEAR
    #define bank0
    #define bank1
    #define bank2
    #define bank3
    #define bit     __osa_uint8
#endif
//------------------------------------------------------------------------------
#if defined(__OSAPICC__)
    #define NEAR    near
    #define bank0   near
#endif

//------------------------------------------------------------------------------
#if   OS_BANK_OS == 0
#define OS_BANK bank0
#elif OS_BANK_OS == 1
#define OS_BANK bank1
#elif OS_BANK_OS == 2
#define OS_BANK bank2
#elif OS_BANK_OS == 3
#define OS_BANK bank3
#else
    #error  "Incorrect OS_BANK_OS value (should be 0, 1, 2 or 3)"
#endif

//------------------------------------------------------------------------------
#if   OS_BANK_TASKS == 0
#define OS_TASKS_BANK bank0
#elif OS_BANK_TASKS == 1
#define OS_TASKS_BANK bank1
#elif OS_BANK_TASKS == 2
#define OS_TASKS_BANK bank2
#elif OS_BANK_TASKS == 3
#define OS_TASKS_BANK bank3
#else
    #error  "Incorrect OS_BANK_TASKS value (should be 0, 1, 2 or 3)"
#endif
//------------------------------------------------------------------------------
#if   OS_BANK_TIMERS == 0
#define OS_TIMERS_BANK bank0
#elif OS_BANK_TIMERS == 1
#define OS_TIMERS_BANK bank1
#elif OS_BANK_TIMERS == 2
#define OS_TIMERS_BANK bank2
#elif OS_BANK_TIMERS == 3
#define OS_TIMERS_BANK bank3
#else
    #error  "Incorrect OS_BANK_TIMERS value (should be 0, 1, 2 or 3)"
#endif
//------------------------------------------------------------------------------
#if   OS_BANK_TIMERS8 == 0
#define OS_TIMERS8_BANK bank0
#elif OS_BANK_TIMERS8 == 1
#define OS_TIMERS8_BANK bank1
#elif OS_BANK_TIMERS8 == 2
#define OS_TIMERS8_BANK bank2
#elif OS_BANK_TIMERS8 == 3
#define OS_TIMERS8_BANK bank3
#else
    #error  "Incorrect OS_BANK_TIMERS8 value (should be 0, 1, 2 or 3)"
#endif
//------------------------------------------------------------------------------
#if   OS_BANK_TIMERS16 == 0
#define OS_TIMERS16_BANK bank0
#elif OS_BANK_TIMERS16 == 1
#define OS_TIMERS16_BANK bank1
#elif OS_BANK_TIMERS16 == 2
#define OS_TIMERS16_BANK bank2
#elif OS_BANK_TIMERS16 == 3
#define OS_TIMERS16_BANK bank3
#else
    #error  "Incorrect OS_BANK_TIMERS16 value (should be 0, 1, 2 or 3)"
#endif
//------------------------------------------------------------------------------
#if   OS_BANK_TIMERS24 == 0
#define OS_TIMERS24_BANK bank0
#elif OS_BANK_TIMERS24 == 1
#define OS_TIMERS24_BANK bank1
#elif OS_BANK_TIMERS24 == 2
#define OS_TIMERS24_BANK bank2
#elif OS_BANK_TIMERS24 == 3
#define OS_TIMERS24_BANK bank3
#else
    #error  "Incorrect OS_BANK_TIMERS24 value (should be 0, 1, 2 or 3)"
#endif
//------------------------------------------------------------------------------
#if   OS_BANK_TIMERS32 == 0
#define OS_TIMERS32_BANK bank0
#elif OS_BANK_TIMERS32 == 1
#define OS_TIMERS32_BANK bank1
#elif OS_BANK_TIMERS32 == 2
#define OS_TIMERS32_BANK bank2
#elif OS_BANK_TIMERS32 == 3
#define OS_TIMERS32_BANK bank3
#else
    #error  "Incorrect OS_BANK_TIMERS32 value (should be 0, 1, 2 or 3)"
#endif
//------------------------------------------------------------------------------
#if   OS_BANK_TIMEOUTS == 0
#define OS_TIMEOUTS_BANK bank0
#elif OS_BANK_TIMEOUTS == 1
#define OS_TIMEOUTS_BANK bank1
#elif OS_BANK_TIMEOUTS == 2
#define OS_TIMEOUTS_BANK bank2
#elif OS_BANK_TIMEOUTS == 3
#define OS_TIMEOUTS_BANK bank3
#else
    #error  "Incorrect OS_BANK_TIMEOUTS value (should be 0, 1, 2 or 3)"
#endif
//------------------------------------------------------------------------------
#if   OS_BANK_BSEM == 0
#define OS_BSEM_BANK bank0
#elif OS_BANK_BSEM == 1
#define OS_BSEM_BANK bank1
#elif OS_BANK_BSEM == 2
#define OS_BSEM_BANK bank2
#elif OS_BANK_BSEM == 3
#define OS_BSEM_BANK bank3
#else
    #error  "Incorrect OS_BANK_BSEM value (should be 0, 1, 2 or 3)"
#endif
//------------------------------------------------------------------------------

















//______________________________________________________________________________
//******************************************************************************
//   
#if OS_TASKS == 0
    #undef OS_TASKS
#endif

#if !defined(OS_TASKS)
    #define OS_TASKS    1       //           
#endif
//------------------------------------------------------------------------------
//   

#if defined(OST_TIMER)
#error "OST_TlMER is not supported in MCC18! Use OS_TIMER_SIZE instead (see manual 3.3)"
#endif

#if !defined(OS_TIMER_SIZE)
    #define OS_TIMER_SIZE   2
#endif

#if   OS_TIMER_SIZE == 1
    #define OST_TIMER __osa_uint8
    #define OS_MAX_DELAY    0xF0
#elif OS_TIMER_SIZE == 2
    #define OST_TIMER __osa_uint16
    #define OS_MAX_DELAY    0xF000
#elif OS_TIMER_SIZE == 4
    #define OST_TIMER __osa_uint32
    #define OS_MAX_DELAY    0xF0000000
#endif




//------------------------------------------------------------------------------

#if defined(__OSAPICC18__)
    #include <osa_picc18.h>         // HT-PICC18
#elif defined(__OSAMCC18__)
    #include <osa_mcc18.h>          // Microchip MCC18
#elif defined(__OSACCS18__)
    #include <osa_ccs18.h>          // CCS-PICC (for PIC18 only)
#elif defined(__OSAPICC__)
    #include <osa_picc.h>           // HT_PICC
#else
    #error "Unknown compiler!"
#endif

//------------------------------------------------------------------------------











//______________________________________________________________________________
//******************************************************************************
//   




//------------------------------------------------------------------------------
//   "  "

#ifndef OST_MSG
    typedef void * OST_MSG;
#endif


typedef struct {
    unsigned char        status;     //  (/)
    OST_MSG     msg;        //   
} OST_PMSG;


//------------------------------------------------------------------------------
//   " "

#ifndef OST_SMSG
    typedef unsigned char   OST_SMSG;
#endif



//------------------------------------------------------------------------------
//   

typedef struct {                //   
    unsigned char cSize;                 //  
    unsigned char cBegin;                //   
    unsigned char cFilled;               //     
} OST_QUEUE_CONTROL;



typedef struct {
    OST_QUEUE_CONTROL Q;
    OST_MSG *pMsg;              //    
} OST_QMSG;


typedef struct {
    OST_QUEUE_CONTROL Q;
    OST_SMSG *pSMsg;            //    
} OST_QSMSG;


//------------------------------------------------------------------------------
// 
#define OST_FLAG    __osa_uint8
#define OST_FLAG16  __osa_uint16
#define OST_FLAG32  __osa_uint32



/*************************************************************************************************************************/
//------------------------------------------------------------------------------





//______________________________________________________________________________

//------------------------------------------------------------------------------
//    
typedef struct {
    unsigned char bEventError:1;             //    
    unsigned char bError:1;                  //    
    unsigned char bInCriticalSection:1;      //      
    unsigned char bCheckingTasks:1;          //  OS_Sched: ==1 -     
                                    //               ==0 -        
    unsigned char bBestTaskFound:1;          //     
                                    // 
    unsigned char bTimeout:1;                //    
    //..........................................................................................
    unsigned char bGIE_CTemp:1;              //  CriticalSection:   GIE 
    unsigned char bGIE_STemp:1;              //     :   GIE 
    
    #ifdef __OSA18__
    unsigned char bGIEL_CTemp:1;             //   GIEL ( PIC18)
    unsigned char bGIEL_STemp:1;             //   GIEL ( PIC18)
    #endif

} OST_SYSTEM_FLAGS;



//------------------------------------------------------------------------------
//   
//   , .. bDelay     
//                         PICC18     OSTimer.h
typedef struct {
    unsigned char cPriority:3;       // 
    unsigned char bReady:1;          //   
    unsigned char bDelay:1;          //   (Delay     )
    unsigned char bCanContinue:1;    // =1, ,   ,     (    )
    unsigned char bEnable:1;
} OST_TASK_STATE;





//------------------------------------------------------------------------------
//   

typedef struct {
    OST_TASK_STATE State;
    OST_CODE_POINTER pTaskPointer;      //   
    #ifdef __OSA18__ 
        unsigned char  cTempFSR1;       //  FSR1   ( MCC18)
    #endif
    #ifdef OS_ENABLE_TIMER
        OST_TIMER Timer;                //       
    #endif
} OST_TCB;   // Task Control Block


#define OS_WORST_PRIORITY       7       //  
#define OS_BEST_PRIORITY        0       //  






//______________________________________________________________________________
//******************************************************************************
//   OS

extern NEAR OST_SYSTEM_FLAGS    OS_Flags;
extern NEAR __osa_uint8         _OS_temp;           //   OS_Sched()    
                                                    //  ,       GIE
extern NEAR __osa_uint8         _OS_tempH;          //   OS_Sched()    
extern NEAR OST_TASK_STATE       OS_state;          //     OS_Sched   State  

extern OST_TASK_POINTER NEAR    _OS_CurTask;        //  
#if defined(OS_ENABLE_PRIORITY)
    extern NEAR __osa_uint8         _OS_best_priority;  //       
    extern OST_TASK_POINTER NEAR    _OS_BestTask;       //     (   OS_Sched() )
    extern OST_TASK_POINTER NEAR    _OS_LastTask;       //   
#endif

extern OS_TASKS_BANK    OST_TCB             OS_TaskVars[OS_TASKS];




#ifdef OS_ENABLE_TIMER

    #ifdef OS_SLOW_TIMERS
        extern NEAR OST_TIMER          OS_Ticks;               //   (   0)
    #elif OS_TIMERS24 > 0
        extern NEAR unsigned char OS_Ticks;
    #endif

    #ifdef OS_ENABLE_PTIMERS
        extern NEAR OST_PTIMER_CB _OS_PTimers;                  //    
    #endif
#endif



//______________________________________________________________________________
//******************************************************************************
//   

#ifndef OS_TIMERS8
    #define OS_TIMERS8 0
#endif

#ifndef OS_TIMERS16
    #define OS_TIMERS16 0
#endif

#ifndef OS_TIMERS24
    #define OS_TIMERS24 0
#endif

#ifndef OS_TIMERS32
    #define OS_TIMERS32 0
#endif


#define _OS_TIMER8_POS      (0)
#define _OS_TIMER16_POS     (_OS_TIMER8_POS  + OS_TIMERS8)
#define _OS_TIMER24_POS     (_OS_TIMER16_POS + OS_TIMERS16)
#define _OS_TIMER32_POS     (_OS_TIMER24_POS + OS_TIMERS24)
#define OS_TIMERS           (OS_TIMERS8 + OS_TIMERS16 + OS_TIMERS24 + OS_TIMERS32)

#if OS_TIMERS > 0
    extern OS_TIMEOUTS_BANK __osa_uint8 OS_Timeouts[];
#endif

#if OS_TIMERS32 > 0
    extern OS_TIMERS32_BANK __osa_uint32 OS_Timers32[];   //   
#endif

#if OS_TIMERS24 > 0
    extern OS_TIMERS24_BANK __osa_uint16  OS_Timers24[];   //    (16-   256)
#endif

#if OS_TIMERS16 > 0
    extern OS_TIMERS16_BANK __osa_uint16  OS_Timers16[];   //   
#endif

#if OS_TIMERS8  > 0
    extern OS_TIMERS8_BANK __osa_uint8 OS_Timers8[];     //   
#endif



#ifdef OS_ENABLE_TIMER
#include <OSTimer.h>
#endif





//______________________________________________________________________________
//******************************************************************************
//  

#ifndef OS_BSEMS
#define OS_BSEMS    0
#endif

#if OS_BSEMS > 0 
    extern OS_BSEM_BANK __osa_uint8 OS_BSems[];
#endif






//______________________________________________________________________________
//******************************************************************************
//   
#ifdef OS_ENABLE_CSEM

    #if !defined(OS_CSEM_SIZE)
        #define OS_CSEM_SIZE    1
    #endif

    #if     OS_CSEM_SIZE == 1
        typedef __osa_uint8 OST_CSEM;
    #elif   OS_CSEM_SIZE == 2
        typedef __osa_uint16 OST_CSEM;
    #elif   OS_CSEM_SIZE == 4
        typedef __osa_uint32 OST_CSEM;
    #else
        #error "Incorrect OS_CSEM_SIZE value (m.b. only 1, 2 or 4)! (see OSAcfg.h)"
    #endif

    extern void _OS_SignalCSem(OST_CSEM *pCSem);

#endif

#if !defined(OS_CSEM_SIZE)
    #define OS_CSEM_SIZE    0
#endif







/*************************************************************************************************************************/



/*************************************************************************************************************************/
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------














/*************************************************************************************************************************/
//------------------------------------------------------------------------------
//   OS

#ifdef OS_ENABLE_TIMER
    extern void _OS_InitDelay(OST_TIMER Delay);
    extern bit  _OS_CheckDelays(void);              //     

    #ifdef OS_FAST_TIMERS
        #define OS_INIT_DELAY(delay)    _OS_InitDelay(delay)
    #else
        #define OS_INIT_DELAY(delay)    _OS_InitDelay(delay)
    #endif

#else
    #define _OS_CheckDelays()           1
#endif

    
extern void _OS_StopTask (void);                //  


#ifdef OS_ENABLE_TIMER
    extern void OS_Timer (void);

    #ifdef OS_ENABLE_PTIMERS
        void _OS_CreatePTimer (OST_PTIMER *ptimer);
        void _OS_DeletePTimer (OST_PTIMER *ptimer);
        #define OS_CreatePTimer(ptimer)     _OS_CreatePTimer(&ptimer)
        #define OS_DeletePTimer(ptimer)     _OS_DeletePTimer(&ptimer)
    #endif


#endif


#ifdef OS_ENABLE_PRIORITY
    extern bit  _OS_CreateTask(unsigned char priority, OST_CODE_POINTER TaskAddr);
#else 
    extern bit  _OS_CreateTask(OST_CODE_POINTER TaskAddr);
#endif


//------------------------------------------------------------------------------
//   
extern void  OS_Init (void);

//------------------------------------------------------------------------------
//   




#ifdef __OSAPICC__
    extern char OS_DI (void);
    #define OS_RI(cSavedInt)    {if (cSavedInt & 0x80) GIE = 1;}
    #define OS_EI()             { GIE = 1;}
#endif


#ifdef __OSAPICC18__
    extern char OS_DI (void);
    extern void OS_RI (char);
    #define OS_EI()         { GIE = 1; if (IPEN) GIEL = 1;}
    #define OS_EIH()        { GIE = 1; }
    #define OS_EIL()        { GIEL = 1; }
#endif

#ifdef __OSAMCC18__
    extern void _OS_RI (void);
    extern char OS_DI (void);
    #define OS_RI(cSavedInt) {_wreg = cSavedInt; _OS_RI();}
    #define OS_EI()         { GIE = 1; if (IPEN) GIEL = 1;}
    #define OS_EIH()        { GIE = 1; }
    #define OS_EIL()        { GIEL = 1; }
#endif


extern void OS_EnterCriticalSection (void);
extern void OS_LeaveCriticalSection (void);



//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
#define OS_WAIT_NO_TIMEOUT          0
#define OS_TASK_ENABLED             1
#define OS_TASK_DISABLED            0








//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////












/*************************************************************************************************************************/
/*                                                                                                                       */
/*                                                                                                                       */
/*                                                    S H E D U L E R                                                    */
/*                                                                                                                       */
/*                                                                                                                       */
/*************************************************************************************************************************/

#ifdef OS_ENABLE_TIMER
    #ifdef OS_FAST_TIMERS
        #define IF_NOT_OS_CHECK_DELAYS_GOTO_SCHED_CONTINUE  if (OS_state.bDelay && !OS_state.bCanContinue)  goto SCHED_CONTINUE;
    #else
        #define IF_NOT_OS_CHECK_DELAYS_GOTO_SCHED_CONTINUE  if (OS_state.bDelay && !_OS_CheckDelays())  goto SCHED_CONTINUE;
    #endif
#else
    #define IF_NOT_OS_CHECK_DELAYS_GOTO_SCHED_CONTINUE
#endif


//------------------------------------------------------------------------------
//    (  )
//          ,  
// ,         , 
//   .
#ifdef OS_ENABLE_PRIORITY

    //      ,  
    //      
    #define OS_IsIdle()     (!OS_IsInCriticalSection() && !OS_Flags.bBestTaskFound)


    #ifdef OS_ENABLE_CRITICAL_SECTION
        #define SKIP_IF_IS_IN_CRITICAL_SECTION()    if (OS_IsInCriticalSection()) goto SCHED_CHECK_READY;
        #define LABEL_SCHED_CHECK_READY             SCHED_CHECK_READY:
    #else
        #define SKIP_IF_IS_IN_CRITICAL_SECTION()
        #define LABEL_SCHED_CHECK_READY 
    #endif



                                                        
    #define OS_Sched()                                                                                  \
        {                                                                                               \
            /*  ,     */                                            \
            OS_Flags.bBestTaskFound = 0;                                                                \
            /*     */                                                      \
            _OS_best_priority = OS_WORST_PRIORITY + 1;                                                  \
            OS_Flags.bCheckingTasks = 1;               /*       */    \
            SKIP_IF_IS_IN_CRITICAL_SECTION();                                                           \
            /*   ,    */                                          \
            _OS_CurTask = _OS_LastTask;                                                                 \
            do                                                                                          \
            {                                                                                           \
                if (_OS_CurTask >= (OST_TASK_POINTER) &OS_TaskVars[OS_TASKS-1])                         \
                    _OS_CurTask = (OST_TASK_POINTER) &OS_TaskVars[0];                                   \
                else                                                                                    \
                    _OS_CurTask++;                                                                      \
                                                                                                        \
        LABEL_SCHED_CHECK_READY                                                                         \
                OS_state = _OS_CurTask->State;      /*      */             \
                                                    /*         */             \
                                                    /*                         */             \
                /* ,     */                                                \
                if (!OS_state.bEnable) goto SCHED_CONTINUE;                                             \
                IF_NOT_OS_CHECK_DELAYS_GOTO_SCHED_CONTINUE;                                             \
                if (_OS_best_priority <= OS_state.cPriority) goto SCHED_CONTINUE;                       \
                if (OS_state.bReady) goto SCHED_SKIP_CHECK;                                             \
                /*      .   */                           \
        SCHED_RUN:;                                                                                     \
                _OS_JumpToTask();                                                                       \
                _OS_SaveRetAddr();                                                                      \
                                                                                                        \
                if (!OS_Flags.bCheckingTasks) goto SCHED_END;                                           \
                /*      */                                           \
                if (OS_state.bReady)                                                                    \
                {                                                                                       \
        SCHED_SKIP_CHECK:                                                                               \
                    OS_Flags.bBestTaskFound = 1;                                                        \
                    _OS_BestTask = _OS_CurTask;                                                         \
                    _OS_best_priority = OS_state.cPriority;                                             \
                    if (_OS_best_priority == OS_BEST_PRIORITY) break;                                   \
                }                                                                                       \
        SCHED_CONTINUE:;                                                                                \
            } while (!OS_IsInCriticalSection() && _OS_CurTask != _OS_LastTask);                         \
            /*      ,    */                                \
            if (OS_Flags.bBestTaskFound)                                                                \
            {                                                                                           \
                OS_Flags.bCheckingTasks = 0;     /*       */      \
                _OS_LastTask = _OS_CurTask = _OS_BestTask;                                              \
                goto SCHED_RUN;                                                                         \
            }                                                                                           \
        SCHED_END:;                                                                                     \
        }                                                                                               \

#endif




#ifndef OS_ENABLE_PRIORITY
//------------------------------------------------------------------------------
//    (  )
//     ,     
//    . ,    ,
//   .       
//   OS_TASKS     .

    #ifdef OS_ENABLE_CRITICAL_SECTION
        #define IF_NOT_IS_IN_CRITICAL_SECTION()        if (!OS_IsInCriticalSection())
    #else
        #define IF_NOT_IS_IN_CRITICAL_SECTION()
    #endif

    #define OS_Sched()                                                              \
        {                                                                           \
            IF_NOT_IS_IN_CRITICAL_SECTION()                                         \
            {                                                                       \
                if (_OS_CurTask >= (OST_TASK_POINTER) &OS_TaskVars[OS_TASKS-1])     \
                    _OS_CurTask = (OST_TASK_POINTER) &OS_TaskVars[0];               \
                else                                                                \
                    _OS_CurTask++;                                                  \
            }                                                                       \
            OS_state = _OS_CurTask->State;                                          \
            /* ,     */                                \
            if (!OS_state.bEnable) goto SCHED_CONTINUE;                             \
            IF_NOT_OS_CHECK_DELAYS_GOTO_SCHED_CONTINUE;                             \
            _OS_JumpToTask();                                                       \
            _OS_SaveRetAddr();                                                      \
        SCHED_CONTINUE:;                                                            \
        }                                                                           

#endif    
/*************************************************************************************************************************/
















/*************************************************************************************************************************/
/*************************************************************************************************************************/

/************************************************************************/
/*                                                                      */
/*                                                     */
/*                                                                      */
/************************************************************************/
        

#define _OS_SetIndfReady()          {((near OST_TASK_STATE*)(&_indf))->bReady = 1;}
#define _OS_SetIndfCanContinue()    {((near OST_TASK_STATE*)(&_indf))->bCanContinue = 1;}
#define _OS_SetIndfDelay()          {((near OST_TASK_STATE*)(&_indf))->bDelay = 1;}

#define _OS_ClearIndfReady()        {((near OST_TASK_STATE*)(&_indf))->bReady = 0;}
#define _OS_ClearIndfCanContinue()  {((near OST_TASK_STATE*)(&_indf))->bCanContinue = 0;}
#define _OS_ClearIndfDelay()        {((near OST_TASK_STATE*)(&_indf))->bDelay = 0;}

#define _OS_CheckIndfReady()        (((near OST_TASK_STATE*)(&_indf))->bReady)
#define _OS_CheckIndfDelay()        (((near OST_TASK_STATE*)(&_indf))->bDelay)
#define _OS_CheckIndfCanContinue()  (((near OST_TASK_STATE*)(&_indf))->bCanContinue)
#define _OS_CheckIndfTimeout()      (!((near OST_TASK_STATE*)(&_indf))->bDelay)










//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     T A S K S                                                                                */
/*                                                                                                              */
/****************************************************************************************************************/

/************************************************************************/
/*                                                                      */
/*     (     ) */
/*                                                                      */
/************************************************************************/
extern void _OS_StopTask (void);

#define OS_StopTask()       { _OS_StopTask(); _OS_Return(); }


/************************************************************************/
/*                                                                      */
/*    .          */
/*                                                                      */
/************************************************************************/
#define OS_ReplaceTask(priority, TaskAddr)                      \
    {                                                           \
        _OS_StopTask();                                         \
        OS_CreateTask(priority, TaskAddr);                      \
        _OS_Return();                                           \
    }        


/****************************************************************************/
/*                                                                          */
/*                                            */
/*      CARRY == 1,   , */
/*  == 0,       .                      */
/*                                                                          */
/****************************************************************************/

#ifdef OS_ENABLE_PRIORITY

    #if defined (__OSAMCC18__)
        #define OS_CreateTask(priority, TaskName)                           \
            {                                                               \
                _OS_CreateTask(priority, (OST_CODE_POINTER)TaskName);       \
            }
    #elif defined(__OSACCS18__)
        #define OS_CreateTask(priority, TaskName)                           \
            {                                                               \
                _OS_CreateTask(priority, (OST_CODE_POINTER)TaskName);       \
                if (_pcl & 1) TaskName();                                   \
            }
    #else
        #define OS_CreateTask(priority, TaskName)                           \
            {                                                               \
                asm("\t global _main       ");                              \
                asm("\t global _" #TaskName);                               \
                asm("\t fncall _main,_" #TaskName);                         \
                _OS_CreateTask(priority, (OST_CODE_POINTER)TaskName);       \
            }
    #endif

#endif


#ifndef OS_ENABLE_PRIORITY


    #if defined (__OSAMCC18__)
        #define OS_CreateTask(priority, TaskName)                           \
            {                                                               \
                _OS_CreateTask((OST_CODE_POINTER)TaskName);                 \
            }
    #elif defined(__OSACCS18__)
        #define OS_CreateTask(priority, TaskName)                           \
            {                                                               \
                _OS_CreateTask((OST_CODE_POINTER)TaskName);                 \
                if (_pcl & 1) TaskName();                                   \
            }
    #else
        #define OS_CreateTask(priority, TaskName)                           \
            {                                                               \
                asm("\t global _main       ");                              \
                asm("\t global _" #TaskName);                               \
                asm("\t fncall _main,_" #TaskName);                         \
                _OS_CreateTask((OST_CODE_POINTER)TaskName);                 \
            }
    #endif

#endif


/************************************************************************/
/*                                                                      */
/*                */
/*                                                                      */
/************************************************************************/

#ifdef OS_ENABLE_PRIORITY
    #define OS_CreateTaskP(priority, TaskAddr)      _OS_CreateTask(priority, TaskAddr)
#else
    #define OS_CreateTaskP(priority, TaskAddr)      _OS_CreateTask(TaskAddr)
#endif

//   ,   OS_CreateTaskP,    
//   main,      
#define OS_ReserveTask(TaskName)                                        \
        {                                                               \
            asm("\t global _main       ");                              \
            asm("\t global _" #TaskName);                               \
            asm("\t fncall _main,_" #TaskName);                         \
        }




/************************************************************************/
/*                                                                      */
/* /                            */
/*                                                                      */
/************************************************************************/

#define OS_GetTaskPriority()                    OS_CurTask->State.Priority
#define OS_SetTaskPriority(new_priority)        {OS_CurTask->State.Priority = new_priority;}

#define OS_GetPriority()                        OS_CurTask->State.Priority
#define OS_SetPriority(new_priority)            {OS_CurTask->State.Priority = new_priority;}







/************************************************************************/
/*                                                                      */
/*              */
/*                                                                      */
/************************************************************************/

#define OS_EnterInt()                                   \
    static _FSR_TYPE   _OS_FSR_Temp;                    \
    _OS_FSR_Temp = _fsr;                                \

/************************************************************************/
/*                                                                      */
/*                  */
/*                                                                      */
/************************************************************************/

#define OS_LeaveInt()   _fsr = _OS_FSR_Temp









/************************************************************************************
 *
 *   :
 *
 ************************************************************************************/

/************************************************************************/
/* 1.                           */
/************************************************************************/
#define OS_Yield()          _OS_GetReturnPoint()

/************************************************************************/
/* 2.                                */
/*    (  )                                       */
/************************************************************************/
#define _OS_Return()        _OS_ReturnNoSave()

/************************************************************************/
/* 3.   ,          */
/************************************************************************/
#define _OS_ClearReady()                    _OS_CLEAR_READY()

/************************************************************************/
/* 4.   ,    ,          */
/*      ,                                        */
/*                           */
/*                          */
/************************************************************************/
#define _OS_ClearReadySetCanContinue()      _OS_CLEAR_READY_SET_CANCONTINUE()









/************************************************************************/
/*                                                                      */
/*                                       */
/*                                                                      */
/************************************************************************/
#define OS_Delay(delaytime)                            \
        {                                              \
            OS_INIT_DELAY(delaytime);                  \
            OS_Yield();                                \
        }                                              \
    
/************************************************************************/
/* ,                                 */
/************************************************************************/
#define OS_IsTimeout()    (OS_Flags.bTimeout)     //    == 0,      





/************************************************************************/
/* ,                                              */
/************************************************************************/
#define OS_IsError()                OS_Flags.bError
#define OS_IsEventError()           OS_Flags.bEventError
#define OS_IsInCriticalSection()    OS_Flags.bInCriticalSection















































/***********************************************************************************************
 *
 *       .   
 *      (,   .)   
 *     .
 *
 ***********************************************************************************************/

#ifdef __OSA16__
    extern bit _OS_CheckEvent (char);
    #define _OS_CHECK_EVENT(event) if (!_OS_CheckEvent(event)) _OS_Return();

#elif defined(__OSAMCC18__)

    extern void _OS_CheckEvent (void);
    #define _OS_CHECK_EVENT(event) {_OS_temp = event; _OS_CheckEvent();}

#elif defined(__OSA18__)

    extern void _OS_CheckEvent (char);
    #define _OS_CHECK_EVENT(event)   _OS_CheckEvent(event)

#endif



    
// !!!   :       , .. 
// event -   ,   ,    FSR. 
//       _OS_xxxIndfxxx()
// ..   (   )  :
//  _fsr = (_FSR_TYPE)&_OS_CurTask->State;


/***********************************************************************************************/
#define _OS_WAIT_EVENT(event)                       \
{                                                   \
    _OS_ClearReady();                               \
    _OS_CHECK_EVENT(event);                         \
}

//------------------------------------------------------------------------------

#define _OS_WAIT_EVENT_TIMEOUT(event, timeout)      \
{                                                   \
    OS_INIT_DELAY(timeout);                         \
    _OS_ClearReadySetCanContinue();                 \
    _OS_CHECK_EVENT(event);                         \
}

/***********************************************************************************************/




















//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     C O N D I T I O N S                                                                      */
/*                                                                                                              */
/****************************************************************************************************************/


/************************************************************************/
/*                                              */
/************************************************************************/
#define OS_WaitCondition(condition)     _OS_WAIT_EVENT(condition)

/************************************************************************/
/*                            */
/************************************************************************/
#define OS_WaitConditionTimeout(condition, timeout)    _OS_WAIT_EVENT_TIMEOUT(condition, timeout)








//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     B I N S E M                                                                              */
/*                                                                                                              */
/****************************************************************************************************************/

//------------------------------------------------------------------------------
//  
#define OS_SetBSem(binsem)       {OS_BSems[(binsem) >> 3] |= (1 << ((binsem) & 7));}
#define OS_SignalBSem(binsem)     OS_SetBSem(binsem)

//------------------------------------------------------------------------------
//  
#define OS_ResetBSem(binsem)     {OS_BSems[(binsem) >> 3] &= ~(1 << ((binsem) & 7));}

//------------------------------------------------------------------------------
// ,   
#define OS_CheckBSem(binsem)     (OS_BSems[(binsem) >> 3] & (1 << ((binsem) & 7)))

//------------------------------------------------------------------------------
//   
#define OS_SwitchBSem(binsem)    {OS_BSems[(binsem) >> 3] ^= (1 << ((binsem) & 7));}
    
//------------------------------------------------------------------------------
//   

#define OS_WaitBSem(binsem)                                           \
    {                                                                 \
        _OS_WAIT_EVENT(OS_CheckBSem(binsem));                         \
        OS_ResetBSem(binsem);                                         \
    }

//-------------------------------------------------------------------------------
//    

#define OS_WaitBSemTimeout(binsem, timeout)                           \
    {                                                                 \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckBSem(binsem), timeout);        \
        OS_ResetBSem(binsem);                                         \
    }


//-------------------------------------------------------------------------------
//        
#define OS_SetWaitBSem(set_binsem, wait_binsem)                       \
    {                                                                 \
        OS_SetBSem(set_binsem);                                       \
        OS_ResetBSem(wait_binsem);                                    \
        OS_WaitBSem(wait_binsem);                                     \
    }


//-------------------------------------------------------------------------------
//          
#define OS_SetWaitBSemTimeout(set_binsem, wait_binsem, timeout)           \
    {                                                                     \
        OS_SetBSem(set_binsem);                                           \
        OS_ResetBSem(wait_binsem);                                        \
        OS_WaitBSemTimeout(wait_binsem);                                  \
    }



    








//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     T I M E R S                                                                              */
/*                                                                                                              */
/****************************************************************************************************************/

//------------------------------------------------------------------------------
//   
#define OS_StopTimer(timer_id)      { OS_Timeouts[(timer_id) >> 3] &= ~(1 << ((timer_id) & 7)); }

//------------------------------------------------------------------------------
//   ( )
#define _OS_RunTimer(timer_id)      { OS_Timeouts[(timer_id) >> 3] |=  (1 << ((timer_id) & 7)); }

//------------------------------------------------------------------------------
// ,    
#define OS_CheckTimer(timer_id)     (!(OS_Timeouts[(timer_id) >> 3] & (1 << ((timer_id) & 7))))

//------------------------------------------------------------------------------
// ,   
#define OS_IsTimerRun(timer_id)     (OS_Timeouts[(timer_id) >> 3] & (1 << ((timer_id) & 7)))


//------------------------------------------------------------------------------
//   8   
#define OS_RunTimer8(timer_id, time)                                \
    {                                                               \
        OS_StopTimer(timer_id);                                     \
        OS_Timers8 [timer_id] = -(time);                            \
        _OS_RunTimer(timer_id);                                     \
    }


//------------------------------------------------------------------------------
//   16   
#define OS_RunTimer16(timer_id, time)                               \
    {                                                               \
        OS_StopTimer(timer_id);                                     \
        OS_Timers16[(timer_id) - _OS_TIMER16_POS] = -(time);          \
        _OS_RunTimer(timer_id);                                     \
    }

//------------------------------------------------------------------------------
//   24   (time -   )
#define OS_RunTimer24(timer_id, time)                                   \
    {                                                                   \
        OS_StopTimer(timer_id);                                         \
        OS_Timers24[(timer_id) - _OS_TIMER24_POS] = - (((time) + 128) >> 8); \
        _OS_RunTimer(timer_id);                                         \
    }
    
//------------------------------------------------------------------------------
//   24     
//    , ..     
//     ,     8.
#define OS_RunTimer24prs(timer_id, time)                            \
    {                                                               \
        OS_StopTimer(timer_id);                                     \
        OS_Timers24[(timer_id) - _OS_TIMER24_POS] = -(time);        \
        _OS_RunTimer(timer_id);                                     \
    }

//------------------------------------------------------------------------------
//   32   
#define OS_RunTimer32(timer_id, time)                               \
    {                                                               \
        OS_StopTimer(timer_id);                                     \
        OS_Timers32[(timer_id) - _OS_TIMER32_POS] = -(time);        \
        _OS_RunTimer(timer_id);                                     \
    }
//------------------------------------------------------------------------------
//     
#define OS_WaitTimer(timer_id)                                              \
    {                                                                       \
        _OS_WAIT_EVENT(OS_CheckTimer(timer_id));                            \
    }
      








//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     S I M P L E     M E S S A G E S                                                          */
/*                                                                                                              */
/****************************************************************************************************************/

//------------------------------------------------------------------------------
// ,   
#define OS_CheckSMsg(smsg)       (smsg != (OST_SMSG)0)

//------------------------------------------------------------------------------
// ,   
#define OS_IsSMsgFree(smsg)       (smsg)

//------------------------------------------------------------------------------
//    (, )
#define _OS_MakeSMsgFree(smsg)          smsg = (OST_SMSG)0

//------------------------------------------------------------------------------
//   
#define OS_CreateSMsg(smsg)             smsg = (OST_SMSG)0

//------------------------------------------------------------------------------
//  
#define OS_SendSMsg(smsg, message)                                      \
    {                                                                   \
        if (OS_CheckSMsg(smsg))                                         \
            _OS_WAIT_EVENT(OS_IsSMsgFree(smsg));                        \
        smsg = (OST_SMSG) message;                                      \
    }

//------------------------------------------------------------------------------
//  ,  ,   ,   
#define OS_SendSMsgNoWait(smsg, message)                                \
    {                                                                   \
        OS_Flags.bEventError = 0;                                       \
        if (OS_CheckSMsg(smsg)) OS_Flags.bEventError = 1;               \
        smsg = (OST_SMSG) message;                                      \
    }

//------------------------------------------------------------------------------
//    
#define OS_SendSMsgTimeout(smsg, message, timeout)                  \
    {                                                               \
        if (OS_CheckSMsg(smsg))                                     \
        {                                                           \
            _OS_WAIT_EVENT_TIMEOUT(OS_IsSMsgFree(smsg), timeout);   \
            if (!OS_IsTimeout()) {                          \
                smsg = (OST_SMSG) message;                          \
            }                                                       \
        } else {                                                    \
            smsg = (OST_SMSG) message;                              \
        }                                                           \
    }                                                    


//------------------------------------------------------------------------------
//   smsg.
//      var  OST_SMSG
#define OS_WaitSMsg(smsg, os_smsg_type_var)                         \
    {                                                               \
        _OS_WAIT_EVENT(OS_CheckSMsg(smsg));                         \
        os_smsg_type_var = smsg;                                    \
        _OS_MakeSMsgFree(smsg);                                     \
    }


//------------------------------------------------------------------------------
//   smsg  .
//      var  OST_SMSG
#define OS_WaitSMsgTimeout(smsg, os_smsg_type_var, timeout)         \
    {                                                               \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckSMsg(smsg), timeout);        \
        os_smsg_type_var = smsg;                                    \
        if (!OS_IsTimeout()) {                              \
            _OS_MakeSMsgFree(smsg);                                 \
        }                                                           \
    }

//------------------------------------------------------------------------------
//   .      
//   ,   .     
// 
#define OS_AcceptSMsg(smsg, os_smsg_type_var)                       \
    {                                                               \
        os_smsg_type_var = smsg;                                    \
        _OS_MakeSMsgFree(smsg);                                     \
    }








//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     F L A G S                                                                                */
/*                                                                                                              */
/****************************************************************************************************************/

//------------------------------------------------------------------------------
//  

#define OS_CreateFlags(flags)               OS_CreateFlag(flags)
#define OS_CreateFlag(flags)                flags = 0


//------------------------------------------------------------------------------
//     

#define OS_InitFlags(flags, value)           OS_InitFlag(flags, value)
#define OS_InitFlag(flags, value)           flags = value

//------------------------------------------------------------------------------
//  ()

#define OS_SetFlags(flags, mask)            OS_SetFlag(flags, mask)
#define OS_SetFlag(flags, mask)             flags |= mask


//------------------------------------------------------------------------------
//  ()

#define OS_ClearFlags(flags, mask)          OS_ClearFlag(flags, mask)
#define OS_ClearFlag(flags, mask)           flags &= ~(mask)


//------------------------------------------------------------------------------
// ,   

#define OS_CheckAllFlags(flags, mask)       OS_CheckAllFlag(flags, mask)
#define OS_CheckAllFlag(flags, mask)        (((flags) & (mask))==(mask))
    
//------------------------------------------------------------------------------
// ,      

#define OS_CheckAnyFlags(flags, mask)       OS_CheckAnyFlag(flags, mask)
#define OS_CheckAnyFlag(flags, mask)        ((flags) & (mask))
    
//------------------------------------------------------------------------------
// ,   

#define OS_CheckAllFlagsClear(flags, mask)  OS_CheckAllFlagClear(flags, mask)
#define OS_CheckAllFlagClear(flags, mask)   (((flags) & (mask)) == 0)
    
//------------------------------------------------------------------------------
// ,      

#define OS_CheckAnyFlagsClear(flags, mask)  OS_CheckAnyFlagClear(flags, mask)
#define OS_CheckAnyFlagClear(flags, mask)   (((flags) & (mask)) != (mask))
    

//------------------------------------------------------------------------------
//  ()

#define OS_WaitAllFlags(flags, mask)        OS_WaitAllFlag(flags, mask)
#define OS_WaitAllFlag(flags, mask)                                     \
    {                                                                   \
        _OS_WAIT_EVENT(OS_CheckAllFlag(flags, mask));                  \
    }

//------------------------------------------------------------------------------
//  ()

#define OS_WaitAnyFlags(flags, mask)        OS_WaitAnyFlag(flags, mask)
#define OS_WaitAnyFlag(flags, mask)                                     \
    {                                                                   \
        _OS_WAIT_EVENT(OS_CheckAnyFlag(flags, mask));                   \
    }


//-------------------------------------------------------------------------------
//  ()  

#define OS_WaitAllFlagsTimeout(flags, mask, timeout)    OS_WaitAllFlagTimeout(flags, mask, timeout)
#define OS_WaitAllFlagTimeout(flags, mask, timeout)                     \
    {                                                                   \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckAllFlag(flags, mask), timeout);  \
    }

//-------------------------------------------------------------------------------
//  ()  

#define OS_WaitAnyFlagsTimeout(flags, mask, timeout)    OS_WaitAnyFlagTimeout(flags, mask, timeout)
#define OS_WaitAnyFlagTimeout(flags, mask, timeout)                     \
    {                                                                   \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckAnyFlag(flags, mask), timeout);  \
    }



//------------------------------------------------------------------------------
//      

#define OS_WaitAllFlagsClear(flags, mask)       OS_WaitAllFlagClear(flags, mask)
#define OS_WaitAllFlagClear(flags, mask)                                \
    {                                                                   \
        _OS_WAIT_EVENT(OS_CheckAllFlagClear(flags, mask));              \
    }

//------------------------------------------------------------------------------
//         

#define OS_WaitAnyFlagsClear(flags, mask)       OS_WaitAnyFlagClear(flags, mask)
#define OS_WaitAnyFlagClear(flags, mask)                                \
    {                                                                   \
        _OS_WAIT_EVENT(OS_CheckAnyFlagClear(flags, mask));              \
    }


//-------------------------------------------------------------------------------
//        

#define OS_WaitAllFlagsClearTimeout(flags, mask, timeout)   OS_WaitAllFlagClearTimeout(flags, mask, timeout)
#define OS_WaitAllFlagClearTimeout(flags, mask, timeout)                        \
    {                                                                           \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckAllFlagClear(flags, mask), timeout);     \
    }

//-------------------------------------------------------------------------------
//           

#define OS_WaitAnyFlagsClearTimeout(flags, mask, timeout)   OS_WaitAnyFlagClearTimeout(flags, mask, timeout)
#define OS_WaitAnyFlagClearTimeout(flags, mask, timeout)                        \
    {                                                                           \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckAnyFlagClear(flags, mask), timeout);     \
    }







//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     C                                                                          */
/*                                                                                                              */
/****************************************************************************************************************/


//        
#if defined(OS_ENABLE_INT_SERVICE) && (OS_CSEM_SIZE > 1)
    #define __OS_CSEM_DI()       {_OS_temp = OS_DI();}
    #define __OS_CSEM_RI()       {OS_RI(_OS_temp);}
#else
    #define __OS_CSEM_DI()
    #define __OS_CSEM_RI()
#endif



//------------------------------------------------------------------------------
//      1
#define OS_SignalCSem(countsem)                     _OS_SignalCSem(&countsem)

//------------------------------------------------------------------------------
//    
#define OS_SetCSemValue(countsem,value)                                 \
    {                                                                   \
        __OS_CSEM_DI();                                                 \
        countsem = value;                                               \
        __OS_CSEM_RI();                                                 \
    }

//------------------------------------------------------------------------------
//   (  ,    )
#define OS_AcceptCSem(countsem)                                         \
    {                                                                   \
        __OS_CSEM_DI();                                                 \
        countsem--;                                                     \
        __OS_CSEM_RI();                                                 \
    }

//      1
#define OS_SetCSem(countsem)                        OS_SetCSemValue(countsem, 1)


//------------------------------------------------------------------------------
#if (OS_CSEM_SIZE == 1) || (!defined(OS_ENABLE_INT_SERVICE))


    //   
    #define OS_ResetCSem(countsem)                      {countsem = 0;}
    #define OS_CreateCSem(countsem)                     {countsem = 0;}

    //   
    #define OS_CheckCSem(countsem)                      (countsem)

//------------------------------------------------------------------------------
#else
//------------------------------------------------------------------------------

    //   
    #define OS_ResetCSem(countsem)                      _OS_ClearCSem(&countsem)
    #define OS_CreateCSem(countsem)                     _OS_ClearCSem(&countsem)

    //   
    #define OS_CheckCSem(countsem)                      _OS_CheckCSem(&countsem)

#endif
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
#ifdef OS_ENABLE_INT_SERVICE
    //    
    #define OS_IntSetCSemValue(countsem,value)          {countsem = value;}

    //      1
    #define OS_IntSetCSem(countsem)                     OS_IntSetCSemValue(countsem, 1)

    //   
    #define OS_IntResetCSem(countsem)                   {countsem = 0;}

    //   
    #define OS_IntCheckCSem(countsem)                   (countsem)

    //   
    #define OS_IntAcceptCSem(countsem)                  {countsem--;}

#endif


//------------------------------------------------------------------------------
//  
#define OS_WaitCSem(countsem)                                           \
    {                                                                   \
        _OS_WAIT_EVENT(OS_CheckCSem(countsem));                         \
        OS_AcceptCSem(countsem);                                        \
    }

//------------------------------------------------------------------------------
//    
#define OS_WaitCSemTimeout(countsem, timeout)                           \
    {                                                                   \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckCSem(countsem), timeout);        \
        if (!OS_IsTimeout()) {                                  \
            OS_AcceptCSem(countsem);                                    \
        }                                                               \
    }







//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     P O I N T E R S   T O   M E S S A G E S                                                  */
/*                                                                                                              */
/****************************************************************************************************************/

//------------------------------------------------------------------------------
// ,   
#define OS_CheckMsg(pmsg)          ((pmsg).status & 1)
#define OS_CheckMsg2(pmsg)          ((pmsg).status)

//------------------------------------------------------------------------------
// / 
#define OS_CreateMsg(pmsg)         {pmsg.status = 0; pmsg.msg = (OST_MSG)0;}
#define OS_ClearMsg(pmsg)          {pmsg.status = 0;}


//------------------------------------------------------------------------------
//  
#define OS_SendMsg(pmsg, value)                                             \
    {                                                                       \
        if (OS_CheckMsg(pmsg)) _OS_WAIT_EVENT(!OS_CheckMsg(pmsg));          \
        pmsg.status = 1;                                                    \
        pmsg.msg = (OST_MSG) value;                                         \
    }

//------------------------------------------------------------------------------
//  ,  ,    
#define OS_SendMsgNoWait(pmsg, value)                                       \
    {                                                                       \
        OS_Flags.bEventError = 0;                                           \
        if (OS_CheckMsg(pmsg)) OS_Flags.bEventError = 1;                    \
        pmsg.status = 1;                                                    \
        pmsg.msg = (OST_MSG) value;                                         \
    }

//------------------------------------------------------------------------------
//    
#define OS_SendMsgTimeout(pmsg, value,timeout)                              \
    {                                                                       \
        if (OS_CheckMsg(pmsg))                                              \
        {                                                                   \
            _OS_WAIT_EVENT_TIMEOUT(!OS_CheckMsg(pmsg), timeout);            \
            if (!OS_IsTimeout()){                                   \
                pmsg.status = 1;                                            \
                pmsg.msg = (OST_MSG) value;                                 \
            }                                                               \
        } else {                                                            \
            pmsg.status = 1;                                                \
            pmsg.msg = (OST_MSG) value;                                     \
        }                                                                   \
    }

//------------------------------------------------------------------------------
//  .
//        var  OST_MSG
#define OS_WaitMsg(pmsg, os_msg_type_var)                           \
    {                                                               \
        _OS_WAIT_EVENT(OS_CheckMsg(pmsg));                          \
        os_msg_type_var = pmsg.msg;                                 \
        OS_ClearMsg(pmsg);                                          \
    }


//------------------------------------------------------------------------------
//    .
//        var  OST_MSG
#define OS_WaitMsgTimeout(pmsg, os_msg_type_var,timeout)            \
    {                                                               \
        os_msg_type_var = (OST_MSG) 0;                              \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckMsg(pmsg), timeout);         \
        if (!OS_IsTimeout()) {                              \
            os_msg_type_var = pmsg.msg;                             \
            OS_ClearMsg(pmsg);                                      \
        }                                                           \
    }


//------------------------------------------------------------------------------
//   .      
//   ,   .     
// 
#define OS_AcceptMsg(pmsg, os_msg_type_var)                         \
    {                                                               \
        os_msg_type_var = pmsg.msg;                                 \
        OS_ClearMsg(pmsg);                                          \
    }









//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     Q U E U E   O F   S I M P L E    M E S S A G E S                                         */
/*                                                                                                              */
/****************************************************************************************************************/

#ifdef OS_ENABLE_QSMSG

extern void         _OS_SendQSMsg (OST_QSMSG *pQSMsg, OST_SMSG SMsg);
extern OST_SMSG     _OS_GetQSMsg (OST_QSMSG *pQSMsg);

#endif

//------------------------------------------------------------------------------
//    

#define OS_CreateQSMsg(qsmsg, buffer, size)                 \
    {                                                       \
        (qsmsg).Q.cSize = size;                             \
        (qsmsg).Q.cBegin = 0;                               \
        (qsmsg).Q.cFilled = 0;                              \
        (qsmsg).pSMsg = (OST_SMSG*)buffer;                  \
    }

//------------------------------------------------------------------------------
//        
#define OS_CheckQSMsg(qsmsg)        ((qsmsg).Q.cFilled)

//------------------------------------------------------------------------------
//    
#define OS_IsQSMsgFull(qsmsg)       ((qsmsg).Q.cFilled == (qsmsg).Q.cSize)

//------------------------------------------------------------------------------
// ,     
#define OS_IsQSMsgFree(qsmsg)       ((qsmsg).Q.cFilled ^ (qsmsg).Q.cSize)


//------------------------------------------------------------------------------
//   
#define OS_ClearQSMsg(qsmsg)        { (qsmsg).Q.cFilled = 0; }

//------------------------------------------------------------------------------
//     
#define OS_SendQSMsg(qsmsg, value)                                      \
    {                                                                   \
        if (OS_IsQSMsgFull(qsmsg))                                      \
            _OS_WAIT_EVENT(OS_IsQSMsgFree(qsmsg));                      \
        _OS_SendQSMsg(&(qsmsg), value);                                 \
    }                                                                   \

//------------------------------------------------------------------------------
//       
#define OS_SendQSMsgTimeout(qsmsg, value, timeout)                      \
    {                                                                   \
        if (OS_IsQSMsgFull(qsmsg))                                      \
        {                                                               \
            _OS_WAIT_EVENT_TIMEOUT(OS_IsQSMsgFree(qsmsg), timeout);     \
            if (!OS_IsTimeout()) {                              \
                _OS_SendQSMsg(&(qsmsg), value);                         \
            }                                                           \
        } else _OS_SendQSMsg(&(qsmsg), value);                          \
    }

//------------------------------------------------------------------------------
//           
#define OS_SendQSMsgNoWait(qsmsg, value)                                \
    {                                                                   \
        _OS_SendQSMsg(&(qsmsg), value);                                 \
    }


//------------------------------------------------------------------------------
//     
#define OS_WaitQSMsg(qsmsg, os_smsg_type_var)                           \
    {                                                                   \
        _OS_WAIT_EVENT(OS_CheckQSMsg(qsmsg));                           \
        os_smsg_type_var = _OS_GetQSMsg(&(qsmsg));                      \
    }

//------------------------------------------------------------------------------
//       
#define OS_WaitQSMsgTimeout(qsmsg, os_smsg_type_var, timeout)           \
    {                                                                   \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckQSMsg(qsmsg), timeout);          \
        if (!OS_IsTimeout())                                    \
        {                                                               \
            os_smsg_type_var = _OS_GetQSMsg(&(qsmsg));                  \
        }                                                               \
    }

//------------------------------------------------------------------------------
//      (    ,   )
#define OS_AcceptQSMsg(qsmsg)    _OS_GetQSMsg(&(qsmsg))


















//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     Q U E U E   O F   M E S S A G E S                                                        */
/*                                                                                                              */
/****************************************************************************************************************/

#ifdef OS_ENABLE_QMSG

extern void _OS_SendQMsg (OST_QMSG *pQMsg, OST_MSG Msg);
extern OST_MSG _OS_GetQMsg (OST_QMSG *pQMsg);

#endif

//------------------------------------------------------------------------------
//   

#define OS_CreateQMsg(qmsg, buffer, size)               \
    {                                                   \
        (qmsg).Q.cSize = size;                          \
        (qmsg).Q.cBegin = 0;                            \
        (qmsg).Q.cFilled = 0;                           \
        (qmsg).pMsg = (OST_MSG*)buffer;                 \
    }

//------------------------------------------------------------------------------
//        
#define OS_CheckQMsg(qmsg)        ((qmsg).Q.cFilled)

//------------------------------------------------------------------------------
//    
#define OS_IsQMsgFull(qmsg)       ((qmsg).Q.cFilled == (qmsg).Q.cSize)

//------------------------------------------------------------------------------
// ,     
#define OS_IsQMsgFree(qmsg)       ((qmsg).Q.cFilled ^ (qmsg).Q.cSize)


//------------------------------------------------------------------------------
//   
#define OS_ClearQMsg(qsmsg)        { (qmsg).Q.cFilled = 0; }

//------------------------------------------------------------------------------
//    
#define OS_SendQMsg(qmsg, value)                                        \
    {                                                                   \
        if (OS_IsQMsgFull(qmsg))                                        \
        {                                                               \
            _OS_WAIT_EVENT(OS_IsQMsgFree(qmsg));                        \
        }                                                               \
        _OS_SendQMsg(&(qmsg), value);                                   \
    }                                                                   \


//------------------------------------------------------------------------------
//      
#define OS_SendQMsgTimeout(qmsg, value, timeout)                        \
    {                                                                   \
        if (OS_IsQMsgFull(qmsg))                                        \
        {                                                               \
            _OS_WAIT_EVENT_TIMEOUT(OS_IsQMsgFree(qmsg), timeout);       \
            if (!OS_IsTimeout()) {                              \
                _OS_SendQMsg(&(qmsg), value);                           \
            }                                                           \
        } else _OS_SendQMsg(&(qmsg), value);                            \
    }

//------------------------------------------------------------------------------
//          
#define OS_SendQMsgNoWait(qmsg, value)                                  \
    {                                                                   \
        _OS_SendQMsg(&(qmsg), value);                                   \
    }


//------------------------------------------------------------------------------
//    
#define OS_WaitQMsg(qmsg, os_msg_type_var)                              \
    {                                                                   \
        _OS_WAIT_EVENT(OS_CheckQMsg(qmsg));                             \
        os_msg_type_var = _OS_GetQMsg(&(qmsg));                         \
    }

//------------------------------------------------------------------------------
//      
#define OS_WaitQMsgTimeout(qmsg, os_msg_type_var, timeout)              \
    {                                                                   \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckQMsg(qmsg), timeout);            \
        if (!OS_IsTimeout())                                    \
        {                                                               \
            os_msg_type_var = _OS_GetQMsg(&(qmsg));                     \
        }                                                               \
    }

//------------------------------------------------------------------------------
//     (    ,   )
#define OS_AcceptQMsg(qmsg)    _OS_GetQMsg(&(qmsg))

























//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     P T I M E R S                                                                            */
/*                                                                                                              */
/****************************************************************************************************************/

#ifdef OS_ENABLE_PTIMERS

/************************************************************************/
/*                                              */
/************************************************************************/

#define OS_CheckPTimer(ptimer)      ((ptimer).Flags.bTimeout)       //   
#define OS_IsPTimerActive(ptimer)   ((ptimer).Flags.bActive)        //        
#define OS_IsPTimerStopped(ptimer)  (!((ptimer).Flags.bRun))        //   
#define OS_IsPTimerRun(ptimer)      ((ptimer).Flags.bRun)           //   

#define OS_StopPTimer(ptimer)          ptimer.Flags.bRun = 0        //  
#define OS_PausePTimer(ptimer)         ptimer.Flags.bRun = 0        //  
#define OS_ContinuePTimer(ptimer)      ptimer.Flags.bRun = 1        //   


/************************************************************************/
/*      time.                             */
/************************************************************************/
#define OS_RunPTimer(ptimer, time)          \
    {                                       \
        (ptimer).Flags.bIsRun = 0;          \
        (ptimer).Timer = -time;             \
        (ptimer).Flags.bTimeout = 0;        \
        (ptimer).Flags.bIsRun = 1;          \
    }

/************************************************************************/
/*      time   ,        */
/*                                      */
/************************************************************************/
#define OS_UpdatePTimer(ptimer, time)       \
    {                                       \
        (ptimer).Flags.bIsRun = 0;          \
        (ptimer).Timer -= time;             \
        (ptimer).Flags.bTimeout = 0;        \
        (ptimer).Flags.bIsRun = 1;          \
    }

/************************************************************************/
/*     time.                                       */
/************************************************************************/
#define OS_AddPTimer(ptimer, time)          \
    {                                       \
        (ptimer).Flags.bIsRun = 0;          \
        (ptimer).Timer -= time;             \
        (ptimer).Flags.bIsRun = 1;          \
    }

/************************************************************************/
/*                                               */
/************************************************************************/
#define OS_GetPTimer(ptimer)      (-(ptimer).Time)

/************************************************************************/
/*                                        */
/************************************************************************/
#define OS_WaitPTimer(ptimer)                   \
    {                                           \
        _OS_WAIT_EVENT(OS_CheckPTimer(ptimer)); \
        (ptimer).Flags.bTimeout = 0;            \
    }




#endif  // OS_ENABLE_PTIMERS











//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     .                                                                                        */
/*                                                                                                              */
/****************************************************************************************************************/


//------------------------------------------------------------------------------
#endif

