#include <salvo.h>








#define TASK_T1_P   OSTCBP(1)
#define TASK_T2_P   OSTCBP(2)
#define TASK_T3_P   OSTCBP(3)


/* Define labels for context switching	*/
_OSLabel(TASK_T1_L)
_OSLabel(TASK_T2_L)
_OSLabel(TASK_T3_L)

_OSLabel(TASK_T1_L2)
_OSLabel(TASK_T2_L2)
_OSLabel(TASK_T3_L2)



/* Define bin semaphores */
#define BINSEM_1    OSECBP(1)
#define BINSEM_2    OSECBP(2)
#define BINSEM_3    OSECBP(3)


unsigned char Counter;

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////

void Task_T1 (void)
{
    for(;;){
        OSSignalBinSem(BINSEM_1);
        Counter++;
        OS_Yield(TASK_T1_L);
        Counter++;
        OS_WaitBinSem(BINSEM_3, 0, TASK_T1_L2);
    }
}
//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////

void Task_T2 (void)
{
    for(;;){
        OSSignalBinSem(BINSEM_2);
        Counter++;
        OS_Yield(TASK_T2_L);
        Counter++;
        OS_WaitBinSem(BINSEM_1, 0, TASK_T2_L2);
    }
}
//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////

void Task_T3 (void)
{
    for(;;){
        OSSignalBinSem(BINSEM_3);
        Counter++;
        OS_Yield(TASK_T3_L);
        Counter++;
        OS_WaitBinSem(BINSEM_2, 0, TASK_T3_L2);
    }
}

//______________________________________________________________________________
////////////////////////////////////////////////////////////////////////////////

void main()
{
    OSInit();
    OSCreateTask(Task_T1,  TASK_T1_P, 5);
    OSCreateTask(Task_T2,  TASK_T2_P, 5);
    OSCreateTask(Task_T3,  TASK_T3_P, 5);

    OSCreateBinSem(BINSEM_1,0);
    OSCreateBinSem(BINSEM_2,0);
    OSCreateBinSem(BINSEM_3,0);

    for(;;){
        asm(" clrwdt ");
        OSSched();
    }
}
